<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="n" uri="next"%>
<%@ taglib prefix="t" uri="template"%>

<t:entrada>
	<t:janelaEntrada showSubmit="false">
		<t:tabelaEntrada>
			<n:panelGrid columns="4" colspan="2" >
				<c:if test="${empty cliente.id}">
					<n:panel colspan="2">&nbsp;${cliente.id}</n:panel>	
				</c:if>
				<t:property name="id" />
				<n:panel colspan="2">&nbsp;</n:panel>
				<t:property name="nome"/>
				<t:property name="nomeFantasia"/>
				<t:property name="telefone" type="TELEFONE"/>
				<t:property name="celular" type="TELEFONE"/>
				<t:property name="dtNasc" type="DATE"/>
			    <t:property name="tipoCadastro"/> 
			    <t:property name="tipoPessoa"/>
				<n:panel propertyRenderAsDouble="true" colspan="2">
					<t:property name="cnpj" type="CNPJ"/>
					<t:property name="cpf" type="CPF"/>
				</n:panel>
				<t:property name="cispoa"/>
				<t:property name="inscricaoEstadual"/>
				<t:property name="inspetoria"/>
				<t:property name="vendedor"/>
			</n:panelGrid>
		</t:tabelaEntrada>
		<t:detalhe name="enderecos">
			<c:if test="${empty endereco.id}">
				<n:panel colspan="2">&nbsp;${endereco.id}</n:panel>	
			</c:if>
			<t:property name="id" />
			<t:property name="tipoEndereco"/>
			<t:property name="endereco.logradouro" />
			<t:property name="endereco.numero" type="INTEGER"/>
			<t:property name="endereco.complemento"/>
			<t:property name="endereco.bairro"/>
			<t:property name="endereco.cidade"/>
			<t:property name="endereco.cep" type="CEP"/>
			<t:property name="endereco.uf" style="text-transform: uppercase;" onkeyup="javascript:this.value=this.value.toUpperCase();"/>
			<t:property name="endereco.pontoReferencia"/>
		</t:detalhe>
		<t:detalhe name="contatos" showBotaoNovaLinha="false" showColunaAcao="false">
			<t:property name="id"/>
			<t:property name="nome" />
			<t:property name="cargo" />
			<t:property name="telefone" type="TELEFONE"/>
			<t:property name="dtNasc" type="DATE"/>
			<t:property name="tipoContato"/>
			<t:property name="email"/>
		</t:detalhe>
		<t:detalhe name="agendas">
			<t:property name="id"/>
			<t:property name="coletador" />
			<t:property name="data" type="DATE"/>
			<t:property name="local" type="TEXT"/>
			<t:property name="tipoAmostra"/>
		</t:detalhe>
	</t:janelaEntrada>
</t:entrada>