<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="n" uri="next"%>
<%@ taglib prefix="t" uri="template"%>

<t:entrada>
	<t:janelaEntrada>
		<t:tabelaEntrada title="Dados Cadastrais">
			<n:panelGrid columns="4" colspan="2" >
				<c:if test="${empty cliente.id}">
					<n:panel colspan="2">&nbsp;${cliente.id}</n:panel>	
				</c:if>
				<t:property name="id" />
				<n:panel colspan="2">&nbsp;</n:panel>
				<t:property name="nome"/>
				<t:property name="nomeFantasia"/>
				<t:property name="telefone" type="TELEFONE"/>
				<t:property name="celular" type="TELEFONE"/>
				<t:property  name="dtNasc" type="DATE"/>
			    <t:property name="tipoCadastro"/> 
			    <t:property name="tipoPessoa"/>
				<n:panel propertyRenderAsDouble="true" colspan="2">
					<t:property name="cnpj" type="CNPJ"/>
					<t:property name="cpf" type="CPF"/>
				</n:panel>
				<t:property name="cispoa"/>
				<t:property name="inscricaoEstadual"/>
				<t:property name="inspetoria"/>
				<t:property name="vendedor"/>
			</n:panelGrid>
		</t:tabelaEntrada>
		<t:detalhe name="enderecos">
			<n:column>
				<n:panelGrid columns="6" propertyRenderAsDouble="true" id="ender">
					<c:if test="${empty enderecoCliente.id}">
						<n:panel colspan="2">&nbsp;${enderecoCliente.id}</n:panel>	
					</c:if>
				    <t:property name="id" />
					<t:property name="tipoEndereco" colspan="4"/>
          			<t:property name="endereco.logradouro" />
					<t:property name="endereco.numero" type="INTEGER"/>
					<t:property name="endereco.complemento"/>
					<t:property name="endereco.bairro"/>
					<t:property name="endereco.cidade"/>
					<t:property name="endereco.cep" type="CEP"/>
					<t:property name="endereco.uf" style="text-transform: uppercase;" onkeyup="javascript:this.value=this.value.toUpperCase();"/>
					<t:property name="endereco.pontoReferencia"/>
				</n:panelGrid>
			</n:column>
		</t:detalhe>
		<t:detalhe name="contatos">
			<t:property name="id" type="HIDDEN" write="true"/>
			<t:property name="nome"/>
			<t:property name="cargo"/>
			<t:property name="telefone" type="TELEFONE"/>
			<t:property name="dtNasc" type="DATE"/>
			<t:property name="email" style="text-transform: lowercase;" onkeyup="javascript:this.value=this.value.toLowerCase();"/>
			<t:property name="tipoContato"/>
			<t:property name="emailLaudo" type="CHECKBOX"  includeBlank="FALSE"/>
		</t:detalhe>
		<t:detalhe name="agendas">
			<t:property name="id" type="HIDDEN" write="true"/>
			<t:property name="coletador" />
			<t:property name="data" type="DATE"/>
			<t:property name="local" type="TEXT"/>
			<t:property name="tipoAmostra"/>
		</t:detalhe>
	</t:janelaEntrada>
</t:entrada>