<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="n" uri="next"%>
<%@ taglib prefix="t" uri="template"%>

<t:entrada>
	<t:janelaEntrada showSubmit="false">
		<t:tabelaEntrada>
			<n:panelGrid columns="4" rowStyles="border:true">
				<t:property name="id"/>
				<t:property name="cliente" size="60" selectOnePath="/cadastro/crud/Cliente" useAjax="true" />
				<t:property name="dataEmissao" type="DATE" id="f_dataEmissao"/>
				<t:property name="dataVencimento" type="DATE" />
				<t:property name="numeroNf" type="INTEGER" />
				<n:panel>Referncia Ms/Ano</n:panel>
				<n:panel>
					<t:property name="mes" />
					<t:property name="ano" pattern="####"/>
				</n:panel>
				<t:property name="tipoDocEnum"/>
				<t:property name="situacaoDocEnum"/>
				<t:property name="observacao" type="TEXT_AREA" cols="50" rows="3" colspan="4"/>
				<n:panelGrid columns="4"  colspan="2">
					<t:property name="valorTotal" write="true" type="HIDDEN" panelStyle="font-weight: bold;"/>
					<t:property name="valorImpostos" write="true" type="HIDDEN" panelStyle="color:red;font-weight: bold;"/>
				</n:panelGrid>
				<t:property name="valorLiquido" write="true" type="HIDDEN" panelStyle="color:blue;font-weight: bold;"/>
			</n:panelGrid>
		</t:tabelaEntrada >
		<t:detalhe name="itensDocumento" showBotaoNovaLinha="false" showColunaAcao="false">
		    <t:property name="id"/>
			<t:property name="idDoc"/>
			<t:property name="descricao"/>
			<t:property name="tipoDocumento"/>
			<t:property name="valor"/>
		</t:detalhe>
		<t:detalhe name="impostosDocumento">
		    <t:property name="id" type="HIDDEN" write="true"/>
			<t:property name="imposto"/>
			<t:property name="percentual"  type="FLOAT" pattern="####,##,#0.00" />
			<t:property name="valor" type="HIDDEN" write="true" />
		</t:detalhe>
		<t:detalhe name="parcelas" showBotaoNovaLinha="false" showColunaAcao="false">
			<t:property name="id" headerStyle="width:50px;text-align:right;"/>
			<t:property name="documento" bodyStyle="text-align:right;" headerStyle="text-align:right;width:50px;"/>
			<t:property name="documento.cliente" />
			<t:property name="documento.tipoDocEnum" />
			<t:property name="parcelaSeq" headerStyle="text-align:right;"/>
			<t:property name="dataProcessamento"/>
			<t:property name="dataVencimento" type="DATE"/>
			<t:property name="valorParcela" type="MONEY" headerStyle="text-align:right;"/>
			<t:property name="dataPagamento" type="DATE"/>
			<t:property name="valorPagamento" type="MONEY" headerStyle="text-align:right;"/>
		</t:detalhe>
	</t:janelaEntrada>		
</t:entrada>		