package br.com.mss.labqp;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.MappedSuperclass;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.format.annotation.DateTimeFormat.ISO;

import br.com.mss.labqp.geral.FiltroExcluidoEnum;

@MappedSuperclass
public abstract class BasicBeanAudit extends BasicBean {
		
	/**
	 * 
	 */
	private static final long serialVersionUID = 5107809834151625347L;
	
	private String userInc;
	private String userAtu;
	private String userExc;
	private Date dataInc;
	private Date dataAtu;
	private Date dataExc;
	private FiltroExcluidoEnum filtroExcluidoEnum;

	/**
	 * @return the userInc
	 */
	@Column(length = 15)
	@MaxLength(15)
	public String getUserInc() {
		return userInc;
	}

	/**
	 * @param userInc the userInc to set
	 */
	public void setUserInc(String userInc) {
		this.userInc = userInc;
	}

	/**
	 * @return the userAtu
	 */
	@Column(length = 15)
	@MaxLength(15)
	public String getUserAtu() {
		return userAtu;
	}

	/**
	 * @param userAtu the userAtu to set
	 */
	public void setUserAtu(String userAtu) {
		this.userAtu = userAtu;
	}

	/**
	 * @return the dataInc
	 */
	@DateTimeFormat(iso=ISO.DATE_TIME, pattern="dd/MM/yyyy HH:mm:ss")
	@Temporal(TemporalType.TIMESTAMP)
	public Date getDataInc() {
		return dataInc;
	}

	/**
	 * @param dataInc the dataInc to set
	 */
	public void setDataInc(Date dataInc) {
		this.dataInc = dataInc;
	}

	/**
	 * @return the dataAtu
	 */
	@DateTimeFormat(iso=ISO.DATE_TIME, pattern="dd/MM/yyyy HH:mm:ss")
	@Temporal(TemporalType.TIMESTAMP)
	public Date getDataAtu() {
		return dataAtu;
	}

	/**
	 * @param dataAtu the dataAtu to set
	 */
	public void setDataAtu(Date dataAtu) {
		this.dataAtu = dataAtu;
	}

	/**
	 * @return the userExc
	 */
	@Column(length = 15)
	@MaxLength(15)
	public String getUserExc() {
		return userExc;
	}

	/**
	 * @param userExc the userExc to set
	 */
	public void setUserExc(String userExc) {
		this.userExc = userExc;
	}

	/**
	 * @return the dataExc
	 */
	@DateTimeFormat(iso=ISO.DATE_TIME, pattern="dd/MM/yyyy HH:mm:ss")
	@Temporal(TemporalType.TIMESTAMP)
	public Date getDataExc() {
		return dataExc;
	}

	/**
	 * @param dataExc the dataExc to set
	 */
	public void setDataExc(Date dataExc) {
		this.dataExc = dataExc;
	}

	/**
	 * @return the filtroExcluidoEnum
	 */
	@Enumerated(EnumType.ORDINAL)
	@DisplayName("Excludo")
	@Transient
	public FiltroExcluidoEnum getFiltroExcluidoEnum() {
		if (this.dataExc == null) 
			filtroExcluidoEnum = FiltroExcluidoEnum.NAO;
		else
			filtroExcluidoEnum = FiltroExcluidoEnum.SIM;
		return filtroExcluidoEnum;
	}

	/**
	 * @param filtroExcluidoEnum the filtroExcluidoEnum to set
	 */
	public void setFiltroExcluidoEnum(FiltroExcluidoEnum filtroExcluidoEnum) {
		this.filtroExcluidoEnum = filtroExcluidoEnum;
	}
}
