package br.com.mss.labqp;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.MappedSuperclass;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.nextframework.bean.annotation.DescriptionProperty;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;
import org.springframework.format.annotation.DateTimeFormat;

import br.com.mss.labqp.geral.entity.Arquivo;

@MappedSuperclass
public abstract class Pessoa extends BasicBeanAudit {

	/**
	 * 
	 */
	private static final long serialVersionUID = -1495462413812997695L;
	private String nome;
	private Arquivo foto;
	private Date dtNasc;

	@DescriptionProperty
	@Required
	@Column(length = 50,unique=true,nullable=false)
	@MaxLength(50)
	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	public Arquivo getFoto() {
		return foto;
	}

	public void setFoto(Arquivo foto) {
		this.foto = foto;
	}

	@DateTimeFormat
	@Temporal(TemporalType.DATE)
	@DisplayName("Data Nascimento")
	public Date getDtNasc() {
		return dtNasc;
	}

	public void setDtNasc(Date dtNasc) {
		this.dtNasc = dtNasc;
	}

}
