package br.com.mss.labqp.admin.dao;

import org.nextframework.controller.crud.FiltroListagem;
import org.nextframework.persistence.GenericDAO;
import org.nextframework.persistence.QueryBuilder;
import org.nextframework.persistence.SaveOrUpdateStrategy;

import br.com.mss.labqp.admin.entity.Colaborador;

public class ColaboradorDAO extends GenericDAO<Colaborador> {
	
	@Override
	public void updateListagemQuery(QueryBuilder<Colaborador> query,
			FiltroListagem filtro) {
		query.leftOuterJoinFetch("colaborador.foto");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.nextframework.persistence.GenericDAO#updateSaveOrUpdate(org.nextframework
	 * .persistence.SaveOrUpdateStrategy)
	 */
	@Override
	public void updateSaveOrUpdate(SaveOrUpdateStrategy save) {
		save.saveOrUpdateManaged("papeis");
		save.saveOrUpdateManaged("endereco");
		super.updateSaveOrUpdate(save);
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateEntradaQuery(org.nextframework.persistence.QueryBuilder)
	 */
	@Override
	public void updateEntradaQuery(QueryBuilder<Colaborador> query) {
		query.fetchCollection("papeis");
		query.fetchCollection("endereco");
		super.updateEntradaQuery(query);
	}

}
