package br.com.mss.labqp.admin.entity;

import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;

import org.nextframework.authorization.User;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.types.Password;
import org.nextframework.validation.annotation.MaxLength;
import org.springframework.format.annotation.DateTimeFormat;

import br.com.mss.labqp.Pessoa;

@Entity
@Table(name = "colaborador")
@DisplayName("Colaborador")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_COLABORADOR_ID")
public class Colaborador extends Pessoa implements User {

	/**
	 * 
	 */
	private static final long serialVersionUID = 5062438774751687152L;

	private String login;
	private String password;
	private String horaLogin;
	private List<ColaboradorPapel> papeis;

	/**
	 * @return the horaLogin
	 */
	@DateTimeFormat
	@Temporal(TemporalType.TIMESTAMP)
	@DisplayName("Logado em ")
	@Transient
	public String getHoraLogin() {
		return horaLogin;
	}

	/**
	 * @param horaLogin the horaLogin to set
	 */
	public void setHoraLogin(String horaLogin) {
		this.horaLogin = horaLogin;
	}


	
	/**
	 * @return the login
	 */
	@Column(length = 15,unique=true,insertable=true,updatable=true)
	@MaxLength(15)
	public String getLogin() {
		return login;
	}

	/**
	 * @param login
	 *            the login to set
	 */
	public void setLogin(String login) {
		this.login = login;
	}

	/**
	 * @return the password
	 */
	@Column(length = 15)
	@MaxLength(15)
	@Password
	public String getPassword() {
		return password;
	}

	/**
	 * @param password
	 *            the password to set
	 */
	public void setPassword(String password) {
		this.password = password;
	}

	/**
	 * @return the papeis
	 */
	@OneToMany(mappedBy = "colaborador")
	public List<ColaboradorPapel> getPapeis() {
		return papeis;
	}

	/**
	 * @param papeis
	 *            the papeis to set
	 */
	public void setPapeis(List<ColaboradorPapel> papeis) {
		this.papeis = papeis;
	}

}
