package br.com.mss.labqp.admin.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.nextframework.authorization.Role;
import org.nextframework.bean.annotation.DescriptionProperty;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBeanAudit;

@Entity
@Table(name = "papel")
@DisplayName("Papel")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_PAPEL_ID")
public class Papel extends BasicBeanAudit implements Role {

	/**
	 * 
	 */
	private static final long serialVersionUID = 8860381707213607577L;
	private String name;
	private String description;

	/**
	 * @return the name
	 */
	@DescriptionProperty
	@Column(length = 50,unique=true,nullable=false)
	@MaxLength(50)
	@DisplayName("Nome")
	@Required
	public String getName() {
		return name;
	}

	/**
	 * @param name
	 *            the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the description
	 */
	@DisplayName("Descrio")
	@Column(length = 100,nullable=false)
	@MaxLength(100)
	public String getDescription() {
		return description;
	}

	/**
	 * @param description
	 *            the description to set
	 */
	public void setDescription(String description) {
		this.description = description;
	}

}
