package br.com.mss.labqp.admin.entity;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.nextframework.authorization.impl.AbstractPermission;
import org.nextframework.bean.annotation.DisplayName;

@Entity
@Table(name = "permissao")
@DisplayName("Permissao")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_PERMISSAO_ID")
public class Permissao extends AbstractPermission {

	private Integer id;
	private Papel role;
	private String permissionString;
	private String path;

	/**
	 * @return the id
	 */
	@Id
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQUENCE")
	public Integer getId() {
		return id;
	}

	/**
	 * @param id
	 *            the id to set
	 */
	public void setId(Integer id) {
		this.id = id;
	}

	/**
	 * @return the role
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "papel_id")
	public Papel getRole() {
		return role;
	}

	/**
	 * @param role
	 *            the role to set
	 */
	public void setRole(Papel role) {
		this.role = role;
	}

	/**
	 * @return the permissionString
	 */
	public String getPermissionString() {
		return permissionString;
	}

	/**
	 * @param permissionString
	 *            the permissionString to set
	 */
	public void setPermissionString(String permissionString) {
		this.permissionString = permissionString;
	}

	/**
	 * @return the path
	 */
	public String getPath() {
		return path;
	}

	/**
	 * @param path
	 *            the path to set
	 */
	public void setPath(String path) {
		this.path = path;
	}

}
