package br.com.mss.labqp.agenda.dao;

import java.util.Date;
import java.util.List;

import org.nextframework.controller.crud.FiltroListagem;
import org.nextframework.persistence.DefaultOrderBy;
import org.nextframework.persistence.QueryBuilder;
import org.nextframework.persistence.ResultList;

import br.com.mss.labqp.GenericAuditDAO;
import br.com.mss.labqp.agenda.entity.Agenda;
import br.com.mss.labqp.agenda.entity.AgendaFiltro;
import br.com.mss.labqp.geral.FiltroExcluidoEnum;

@DefaultOrderBy("agenda.cliente.id, agenda.coletador.id, agenda.data")
public class AgendaDAO extends GenericAuditDAO<Agenda> {

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateListagemQuery(org.nextframework.persistence.QueryBuilder, org.nextframework.controller.crud.FiltroListagem)
	 */
	@Override
	public void updateListagemQuery(QueryBuilder<Agenda> query,
			FiltroListagem _filtro) {

		AgendaFiltro filtro = (AgendaFiltro) _filtro;
		Date[] datas = { filtro.getDataI(), filtro.getDataF() };

		query.where("agenda.id = ?",filtro.getId());
		query.where("agenda.cliente = ?",filtro.getCliente());
		query.where("agenda.coletador = ?",filtro.getColetador());
		query.where("agenda.tipoAmostra = ?",filtro.getTipoAmostra());
		query.where("agenda.data between ? and ? ", datas);
		query.whereLike("agenda.local", filtro.getLocal());
		if (filtro.getFiltroExcluido() != null) {
			if (filtro.getFiltroExcluido() == FiltroExcluidoEnum.SIM)
				query.where("agenda.dataExc is not null");
			else
				query.where("agenda.dataExc is null");

		}
	}

	/* (non-Javadoc)
	 * @see br.com.mss.labqp.GenericAuditDAO#getQueryFindForCombo(java.lang.String)
	 */
	@Override
	protected String getQueryFindForCombo(String hbQueryFindForCombo) {
		// TODO Auto-generated method stub
		return super.getQueryFindForCombo(hbQueryFindForCombo);
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#findForCombo(java.lang.String[])
	 */
	@Override
	public List<Agenda> findForCombo(String... extraFields) {
		// TODO Auto-generated method stub
		return super.findForCombo(extraFields);
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#findForListagem(org.nextframework.controller.crud.FiltroListagem)
	 */
	@Override
	public ResultList<Agenda> findForListagem(FiltroListagem filtro) {
		// TODO Auto-generated method stub
		return super.findForListagem(filtro);
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#findPropertiesForClass(java.lang.Class)
	 */
	@Override
	protected String[] findPropertiesForClass(
			Class<? extends Object> propertyClass) {
		// TODO Auto-generated method stub
		return super.findPropertiesForClass(propertyClass);
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#getComboSelect(java.lang.String[])
	 */
	@Override
	public String getComboSelect(String... extraFields) {
		// TODO Auto-generated method stub
		return super.getComboSelect(extraFields);
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#getComboSelectedProperties(java.lang.String)
	 */
	@Override
	protected String[] getComboSelectedProperties(String alias) {
		// TODO Auto-generated method stub
		return super.getComboSelectedProperties(alias);
	}
	
}
