package br.com.mss.labqp.agenda.entity;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;
import org.springframework.format.annotation.DateTimeFormat;

import br.com.mss.labqp.BasicBeanAudit;
import br.com.mss.labqp.cadastro.entity.Cliente;
import br.com.mss.labqp.cadastro.entity.Coletador;
import br.com.mss.labqp.cadastro.entity.TipoAmostra;

@Entity
@Table(name = "agenda")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_AGENDA_ID")
@DisplayName("Agenda ")
public class Agenda extends BasicBeanAudit {

	/**
	 * 
	 */
	private static final long serialVersionUID = 170781901451599322L;
	private Cliente cliente;
	private Coletador coletador;
	private Date data;
	private String local;
	private TipoAmostra tipoAmostra;
	private Boolean selecionado;

	@ManyToOne(fetch = FetchType.LAZY)
	@Required
	public Cliente getCliente() {
		return cliente;
	}

	public void setCliente(Cliente cliente) {
		this.cliente = cliente;
	}

	/**
	 * @return the data
	 */
	@DateTimeFormat()
	@Temporal(TemporalType.DATE)
	@Required
	public Date getData() {
		return data;
	}

	/**
	 * @param data the data to set
	 */
	public void setData(Date data) {
		this.data = data;
	}

	/**
	 * @return the local
	 */
	@DisplayName("Local")
	@Column(length = 100)
	@MaxLength(100)
	public String getLocal() {
		return local;
	}

	/**
	 * @param local the local to set
	 */
	public void setLocal(String local) {
		this.local = local;
	}

	/**
	 * @return the tipoAmostra
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	public TipoAmostra getTipoAmostra() {
		return tipoAmostra;
	}

	/**
	 * @param tipoAmostra the tipoAmostra to set
	 */
	public void setTipoAmostra(TipoAmostra tipoAmostra) {
		this.tipoAmostra = tipoAmostra;
	}

	/**
	 * @return the coletador
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	@Required
	public Coletador getColetador() {
		return coletador;
	}

	/**
	 * @param coletador the coletador to set
	 */
	public void setColetador(Coletador coletador) {
		this.coletador = coletador;
	}

	/**
	 * @return the selecionado
	 */
	@Transient
	public Boolean getSelecionado() {
		return selecionado;
	}

	/**
	 * @param selecionado the selecionado to set
	 */
	public void setSelecionado(Boolean selecionado) {
		this.selecionado = selecionado;
	}

}
