package br.com.mss.labqp.agenda.entity;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.springframework.format.annotation.DateTimeFormat;

import br.com.mss.labqp.FiltroListagemAudit;
import br.com.mss.labqp.cadastro.entity.Cliente;
import br.com.mss.labqp.cadastro.entity.Coletador;
import br.com.mss.labqp.cadastro.entity.TipoAmostra;

public class AgendaFiltro extends FiltroListagemAudit {

	/**
	 * 
	 */
	private Long id;
	private Cliente cliente;
	private Coletador coletador;
	private Date dataI;
	private Date dataF;
	private String local;
	private TipoAmostra tipoAmostra;

	@ManyToOne(fetch = FetchType.LAZY)
	public Cliente getCliente() {
		return cliente;
	}

	public void setCliente(Cliente cliente) {
		this.cliente = cliente;
	}

	/**
	 * @return the local
	 */
	@DisplayName("Local")
	@Column(length = 100)
	@MaxLength(100)
	public String getLocal() {
		return local;
	}

	/**
	 * @param local the local to set
	 */
	public void setLocal(String local) {
		this.local = local;
	}

	/**
	 * @return the tipoAmostra
	 */
	public TipoAmostra getTipoAmostra() {
		return tipoAmostra;
	}

	/**
	 * @param tipoAmostra the tipoAmostra to set
	 */
	public void setTipoAmostra(TipoAmostra tipoAmostra) {
		this.tipoAmostra = tipoAmostra;
	}

	/**
	 * @return the coletador
	 */
	public Coletador getColetador() {
		return coletador;
	}

	/**
	 * @param coletador the coletador to set
	 */
	public void setColetador(Coletador coletador) {
		this.coletador = coletador;
	}

	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the dataI
	 */
	@DateTimeFormat()
	@Temporal(TemporalType.DATE)
	public Date getDataI() {
		return dataI;
	}

	/**
	 * @param dataI the dataI to set
	 */
	public void setDataI(Date dataI) {
		this.dataI = dataI;
	}

	/**
	 * @return the dataF
	 */
	@DateTimeFormat()
	@Temporal(TemporalType.DATE)
	public Date getDataF() {
		return dataF;
	}

	/**
	 * @param dataF the dataF to set
	 */
	public void setDataF(Date dataF) {
		this.dataF = dataF;
	}

}
