package br.com.mss.labqp.cadastro.dao;

import org.nextframework.controller.crud.FiltroListagem;
import org.nextframework.persistence.DefaultOrderBy;
import org.nextframework.persistence.QueryBuilder;
import org.nextframework.persistence.SaveOrUpdateStrategy;

import br.com.mss.labqp.GenericAuditDAO;
import br.com.mss.labqp.cadastro.entity.Coletador;
import br.com.mss.labqp.cadastro.entity.ColetadorFiltro;
import br.com.mss.labqp.geral.FiltroExcluidoEnum;

@DefaultOrderBy("coletador.nome")
public class ColetadorDAO extends GenericAuditDAO<Coletador> {

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateListagemQuery(org.nextframework.persistence.QueryBuilder, org.nextframework.controller.crud.FiltroListagem)
	 */
	@Override
	public void updateListagemQuery(QueryBuilder<Coletador> query,
			FiltroListagem _filtro) {
		ColetadorFiltro filtro = (ColetadorFiltro) _filtro;
		query.whereLike("coletador.nome", filtro.getNome());
		if (filtro.getFiltroExcluido() != null) {
			if (filtro.getFiltroExcluido() == FiltroExcluidoEnum.SIM)
				query.where("coletador.dataExc is not null");
			else
				query.where("coletador.dataExc is null");

		}
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateEntradaQuery(org.nextframework.persistence.QueryBuilder)
	 */
	@Override
	public void updateEntradaQuery(QueryBuilder<Coletador> query) {
		query.fetchCollection("agendas");
		super.updateEntradaQuery(query);
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateSaveOrUpdate(org.nextframework.persistence.SaveOrUpdateStrategy)
	 */
	@Override
	public void updateSaveOrUpdate(SaveOrUpdateStrategy save) {
		save.saveOrUpdateManaged("agendas");
		super.updateSaveOrUpdate(save);
	}

}
