package br.com.mss.labqp.cadastro.dao;

import org.nextframework.controller.crud.FiltroListagem;
import org.nextframework.persistence.DefaultOrderBy;
import org.nextframework.persistence.QueryBuilder;

import br.com.mss.labqp.GenericAuditDAO;
import br.com.mss.labqp.cadastro.entity.Conservante;
import br.com.mss.labqp.cadastro.entity.ConservanteFiltro;
import br.com.mss.labqp.geral.FiltroExcluidoEnum;

@DefaultOrderBy("conservante.nome")
public class ConservanteDAO extends GenericAuditDAO<Conservante> {

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateListagemQuery(org.nextframework.persistence.QueryBuilder, org.nextframework.controller.crud.FiltroListagem)
	 */
	@Override
	public void updateListagemQuery(QueryBuilder<Conservante> query,
			FiltroListagem _filtro) {
		ConservanteFiltro filtro = (ConservanteFiltro) _filtro;
		query.whereLike("conservante.nome", filtro.getNome());
		query.whereLike("conservante.descricao", filtro.getDescricao());
		if (filtro.getFiltroExcluido() != null) {
			if (filtro.getFiltroExcluido() == FiltroExcluidoEnum.SIM)
				query.where("conservante.dataExc is not null");
			else
				query.where("conservante.dataExc is null");

		}
	}

}
