package br.com.mss.labqp.cadastro.dao;

import org.nextframework.controller.crud.FiltroListagem;
import org.nextframework.persistence.DefaultOrderBy;
import org.nextframework.persistence.QueryBuilder;

import br.com.mss.labqp.GenericAuditDAO;
import br.com.mss.labqp.cadastro.entity.Embalagem;
import br.com.mss.labqp.cadastro.entity.EmbalagemFiltro;
import br.com.mss.labqp.geral.FiltroExcluidoEnum;

@DefaultOrderBy("embalagem.nome")
public class EmbalagemDAO extends GenericAuditDAO<Embalagem> {

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateListagemQuery(org.nextframework.persistence.QueryBuilder, org.nextframework.controller.crud.FiltroListagem)
	 */
	@Override
	public void updateListagemQuery(QueryBuilder<Embalagem> query,
			FiltroListagem _filtro) {
		EmbalagemFiltro filtro = (EmbalagemFiltro) _filtro;
		query.whereLike("embalagem.nome", filtro.getNome());
		if (filtro.getFiltroExcluido() != null) {
			if (filtro.getFiltroExcluido() == FiltroExcluidoEnum.SIM)
				query.where("embalagem.dataExc is not null");
			else
				query.where("embalagem.dataExc is null");

		}
	}

}
