package br.com.mss.labqp.cadastro.dao;

import org.nextframework.controller.crud.FiltroListagem;
import org.nextframework.persistence.DefaultOrderBy;
import org.nextframework.persistence.QueryBuilder;
import org.nextframework.persistence.SaveOrUpdateStrategy;

import br.com.mss.labqp.GenericAuditDAO;
import br.com.mss.labqp.cadastro.entity.Ensaio;
import br.com.mss.labqp.cadastro.entity.EnsaioFiltro;
import br.com.mss.labqp.geral.FiltroExcluidoEnum;

@DefaultOrderBy("ensaio.nome")
public class EnsaioDAO extends GenericAuditDAO<Ensaio> {


	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateEntradaQuery(org.nextframework.persistence.QueryBuilder)
	 */
	@Override
	public void updateEntradaQuery(QueryBuilder<Ensaio> query) {
		query.fetchCollection("ensaioKits");
		super.updateEntradaQuery(query);
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateListagemQuery(org.nextframework.persistence.QueryBuilder, org.nextframework.controller.crud.FiltroListagem)
	 */
	@Override
	public void updateListagemQuery(QueryBuilder<Ensaio> query,
			FiltroListagem _filtro) {
		EnsaioFiltro filtro = (EnsaioFiltro) _filtro;
		query.whereLike("ensaio.nome", filtro.getNome());
		if (filtro.getFiltroExcluido() != null) {
			if (filtro.getFiltroExcluido() == FiltroExcluidoEnum.SIM)
				query.where("ensaio.dataExc is not null");
			else
				query.where("ensaio.dataExc is null");

		}
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateSaveOrUpdate(org.nextframework.persistence.SaveOrUpdateStrategy)
	 */
	@Override
	public void updateSaveOrUpdate(SaveOrUpdateStrategy save) {
		save.saveOrUpdateManaged("ensaioKits");
		super.updateSaveOrUpdate(save);
	}
}
