package br.com.mss.labqp.cadastro.dao;

import org.nextframework.controller.crud.FiltroListagem;
import org.nextframework.persistence.DefaultOrderBy;
import org.nextframework.persistence.QueryBuilder;

import br.com.mss.labqp.GenericAuditDAO;
import br.com.mss.labqp.cadastro.entity.MetodoAnalitico;
import br.com.mss.labqp.cadastro.entity.MetodoAnaliticoFiltro;
import br.com.mss.labqp.geral.FiltroExcluidoEnum;

@DefaultOrderBy("metodoAnalitico.nome")
public class MetodoAnaliticoDAO extends GenericAuditDAO<MetodoAnalitico> {

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateListagemQuery(org.nextframework.persistence.QueryBuilder, org.nextframework.controller.crud.FiltroListagem)
	 */
	@Override
	public void updateListagemQuery(QueryBuilder<MetodoAnalitico> query,
			FiltroListagem _filtro) {
		MetodoAnaliticoFiltro filtro = (MetodoAnaliticoFiltro) _filtro;
		query.whereLike("metodoAnalitico.nome", filtro.getNome());
		if (filtro.getFiltroExcluido() != null) {
			if (filtro.getFiltroExcluido() == FiltroExcluidoEnum.SIM)
				query.where("metodoAnalitico.dataExc is not null");
			else
				query.where("metodoAnalitico.dataExc is null");

		}
	}

}
