package br.com.mss.labqp.cadastro.dao;

import org.nextframework.controller.crud.FiltroListagem;
import org.nextframework.persistence.DefaultOrderBy;
import org.nextframework.persistence.QueryBuilder;
import org.nextframework.persistence.SaveOrUpdateStrategy;

import br.com.mss.labqp.GenericAuditDAO;
import br.com.mss.labqp.cadastro.entity.TipoAmostra;
import br.com.mss.labqp.cadastro.entity.TipoAmostraFiltro;
import br.com.mss.labqp.geral.FiltroExcluidoEnum;

@DefaultOrderBy("tipoAmostra.nome")
public class TipoAmostraDAO extends GenericAuditDAO<TipoAmostra> {

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateEntradaQuery(org.nextframework.persistence.QueryBuilder)
	 */
	@Override
	public void updateEntradaQuery(QueryBuilder<TipoAmostra> query) {
		query.fetchCollection("tpAmostraEnsaios");
		super.updateEntradaQuery(query);
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateSaveOrUpdate(org.nextframework.persistence.SaveOrUpdateStrategy)
	 */
	@Override
	public void updateSaveOrUpdate(SaveOrUpdateStrategy save) {
		save.saveOrUpdateManaged("tpAmostraEnsaios");
		super.updateSaveOrUpdate(save);
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateListagemQuery(org.nextframework.persistence.QueryBuilder, org.nextframework.controller.crud.FiltroListagem)
	 */
	@Override
	public void updateListagemQuery(QueryBuilder<TipoAmostra> query,
			FiltroListagem _filtro) {
		TipoAmostraFiltro filtro = (TipoAmostraFiltro) _filtro;
		query.whereLike("tipoAmostra.nome", filtro.getNome());
		if (filtro.getFiltroExcluido() != null) {
			if (filtro.getFiltroExcluido() == FiltroExcluidoEnum.SIM)
				query.where("tipoAmostra.dataExc is not null");
			else
				query.where("tipoAmostra.dataExc is null");

		}
	}

}
