package br.com.mss.labqp.cadastro.dao;

import org.nextframework.controller.crud.FiltroListagem;
import org.nextframework.persistence.DefaultOrderBy;
import org.nextframework.persistence.QueryBuilder;

import br.com.mss.labqp.GenericAuditDAO;
import br.com.mss.labqp.cadastro.entity.TipoDocumento;
import br.com.mss.labqp.cadastro.entity.TipoDocumentoFiltro;
import br.com.mss.labqp.geral.FiltroExcluidoEnum;

@DefaultOrderBy("tipoDocumento.nome")
public class TipoDocumentoDAO extends GenericAuditDAO<TipoDocumento> {

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateListagemQuery(org.nextframework.persistence.QueryBuilder, org.nextframework.controller.crud.FiltroListagem)
	 */
	@Override
	public void updateListagemQuery(QueryBuilder<TipoDocumento> query,
			FiltroListagem _filtro) {
		TipoDocumentoFiltro filtro = (TipoDocumentoFiltro) _filtro;
		query.whereLike("tipoDocumento.nome", filtro.getNome());
		query.where("tipoDocumento.tipoDocEnum = ?", filtro.getTipoDocEnum());
		if (filtro.getFiltroExcluido() != null) {
			if (filtro.getFiltroExcluido() == FiltroExcluidoEnum.SIM)
				query.where("tipoDocumento.dataExc is not null");
			else
				query.where("tipoDocumento.dataExc is null");

		}
	}

}
