package br.com.mss.labqp.cadastro.dao;

import org.nextframework.controller.crud.FiltroListagem;
import org.nextframework.persistence.DefaultOrderBy;
import org.nextframework.persistence.QueryBuilder;

import br.com.mss.labqp.GenericAuditDAO;
import br.com.mss.labqp.cadastro.entity.Unidade;
import br.com.mss.labqp.cadastro.entity.UnidadeFiltro;
import br.com.mss.labqp.geral.FiltroExcluidoEnum;

@DefaultOrderBy("unidade.nome")
public class UnidadeDAO extends GenericAuditDAO<Unidade> {

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateListagemQuery(org.nextframework.persistence.QueryBuilder, org.nextframework.controller.crud.FiltroListagem)
	 */
	@Override
	public void updateListagemQuery(QueryBuilder<Unidade> query,
			FiltroListagem _filtro) {
		UnidadeFiltro filtro = (UnidadeFiltro) _filtro;
		query.whereLike("unidade.nome", filtro.getNome());
		if (filtro.getFiltroExcluido() != null) {
			if (filtro.getFiltroExcluido() == FiltroExcluidoEnum.SIM)
				query.where("unidade.dataExc is not null");
			else
				query.where("unidade.dataExc is null");

		}
	}

}
