package br.com.mss.labqp.cadastro.dao;

import java.util.List;

import org.nextframework.controller.crud.FiltroListagem;
import org.nextframework.persistence.DefaultOrderBy;
import org.nextframework.persistence.QueryBuilder;

import br.com.mss.labqp.GenericAuditDAO;
import br.com.mss.labqp.cadastro.entity.Vendedor;
import br.com.mss.labqp.cadastro.entity.VendedorFiltro;
import br.com.mss.labqp.geral.FiltroExcluidoEnum;
import br.com.mss.labqp.geral.TipoPessoaEnum;

@DefaultOrderBy("vendedor.nome")
public class VendedorDAO extends GenericAuditDAO<Vendedor> {

	@Override
	public void updateListagemQuery(QueryBuilder<Vendedor> query,
			FiltroListagem _filtro) {
		VendedorFiltro filtro = (VendedorFiltro) _filtro;
		query.leftOuterJoinFetch("vendedor.foto");
		query.whereLike("vendedor.nome", filtro.getNome());
		if (filtro.getTipoPessoa() == TipoPessoaEnum.FISICA) {
			query.where("vendedor.cpf", filtro.getCpf());
		} else if (filtro.getTipoPessoa() == TipoPessoaEnum.JURIDICA) {
			query.where("vendedor.cnpj", filtro.getCnpj());
		}
		if (filtro.getTipoPessoa() != null)
			query.where("vendedor.tipoPessoa = "
					+ filtro.getTipoPessoa().ordinal());
		if (filtro.getFiltroExcluido() != null) {
			if (filtro.getFiltroExcluido() == FiltroExcluidoEnum.SIM)
				query.where("vendedor.dataExc is not null");
			else
				query.where("vendedor.dataExc is null");

		}
	}

	public Boolean findByTipoPessoa(TipoPessoaEnum tipoPessoa, String cpf_cnpj) {
		QueryBuilder<Vendedor> query = query();
		if (tipoPessoa == TipoPessoaEnum.FISICA) {
			query.where("vendedor.cpf = '"+  cpf_cnpj  + "'");
		} else if (tipoPessoa == TipoPessoaEnum.JURIDICA) {
			query.where("vendedor.cnpj = '"+  cpf_cnpj + "'");
		}
		query.where("vendedor.dataExc is null");
 		List<Vendedor> vendedors = query.list();
 		
		return (vendedors != null && vendedors.size() > 0);
	}
	

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateEntradaQuery(org.nextframework.persistence.QueryBuilder)
	 */
	@Override
	public void updateEntradaQuery(QueryBuilder<Vendedor> query) {
		query.fetchCollection("clientes");
		super.updateEntradaQuery(query);
	}
}
