package br.com.mss.labqp.cadastro.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.nextframework.bean.annotation.DescriptionProperty;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBeanAudit;

@Entity
@Table(name = "banco")
@DisplayName("Banco")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_BANCO_ID")
public class Banco extends BasicBeanAudit {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2220300948399986100L;
	private String nome;
	private String codigo;

	@DescriptionProperty
	@Required
	@Column(length = 50)
	@MaxLength(50)
	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	/**
	 * @return the codigo
	 */
	@Required
	@Column(length = 4)
	@MaxLength(4)
	@DisplayName("Cdigo")
	public String getCodigo() {
		return codigo;
	}

	/**
	 * @param codigo the codigo to set
	 */
	public void setCodigo(String codigo) {
		this.codigo = codigo;
	}

}
