package br.com.mss.labqp.cadastro.entity;

import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.nextframework.bean.annotation.DescriptionProperty;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.types.Telefone;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBeanAudit;
import br.com.mss.labqp.agenda.entity.Agenda;

@Entity
@Table(name = "coletador")
@DisplayName("Coletador")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_COLETADOR_ID")
public class Coletador extends BasicBeanAudit {

	/**
	 * 
	 */
	private static final long serialVersionUID = 75563700103539679L;
	private String nome;
	private Telefone telefone;
	private Telefone celular;
	private List<Agenda> agendas;

	@DescriptionProperty
	@Required
	@Column(length = 50)
	@MaxLength(50)
	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public void setTelefone(Telefone telefone) {
		this.telefone = telefone;
	}

	@Column(length = 20)
	@MaxLength(20)
	public Telefone getTelefone() {
		return telefone;
	}

	public void setCelular(Telefone celular) {
		this.celular = celular;
	}

	@Column(length = 20)
	@MaxLength(20)
	public Telefone getCelular() {
		return celular;
	}

	/**
	 * @return the agendas
	 */
	@OneToMany(mappedBy = "coletador")
	public List<Agenda> getAgendas() {
		return agendas;
	}

	/**
	 * @param agendas the agendas to set
	 */
	public void setAgendas(List<Agenda> agendas) {
		this.agendas = agendas;
	}

}
