package br.com.mss.labqp.cadastro.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.nextframework.bean.annotation.DescriptionProperty;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBeanAudit;

@Entity
@Table(name = "conservante")
@DisplayName("Conservante")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_CONSERVANTE_ID")
public class Conservante extends BasicBeanAudit {

	/**
	 * 
	 */
	private static final long serialVersionUID = 5093061881501004118L;
	/**
	 * 
	 */

	private String nome;
	private String descricao;

	@DescriptionProperty
	@Required
	@Column(length = 20)
	@MaxLength(20)
	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	/**
	 * @return the descricao
	 */
	@Column(length = 100)
	@MaxLength(100)
	public String getDescricao() {
		return descricao;
	}

	/**
	 * @param descricao the descricao to set
	 */
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}

}
