package br.com.mss.labqp.cadastro.entity;

import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBean;
import br.com.mss.labqp.geral.TipoEnderecoEnum;
import br.com.mss.labqp.geral.entity.Endereco;

@Entity
@Table(name = "enderecoCliente", uniqueConstraints = { @UniqueConstraint(columnNames = {
		"cliente_id", "tipoEndereco" }) })
@DisplayName("Endereo")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_ENDERECO_CLIENTE_ID")
public class EnderecoCliente extends BasicBean {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6040820011996001068L;
	
	private Cliente cliente;
	private TipoEnderecoEnum tipoEndereco;
	private Endereco endereco;

	/**
	 * @return the tipoEndereco
	 */
	@Required
	public TipoEnderecoEnum getTipoEndereco() {
		return tipoEndereco;
	}

	/**
	 * @param tipoEndereco the tipoEndereco to set
	 */
	public void setTipoEndereco(TipoEnderecoEnum tipoEndereco) {
		this.tipoEndereco = tipoEndereco;
	}

	/**
	 * @return the endereco
	 */
	@Embedded
	public Endereco getEndereco() {
		return endereco;
	}

	/**
	 * @param endereco the endereco to set
	 */
	public void setEndereco(Endereco endereco) {
		this.endereco = endereco;
	}

	/**
	 * @return the cliente
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	@Required
	public Cliente getCliente() {
		return cliente;
	}

	/**
	 * @param cliente the cliente to set
	 */
	public void setCliente(Cliente cliente) {
		this.cliente = cliente;
	}
	
}
