package br.com.mss.labqp.cadastro.entity;

import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.nextframework.bean.annotation.DescriptionProperty;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.types.Money;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBeanAudit;

@Entity
@Table(name = "ensaio")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_ENSAIO_ID")
@DisplayName("Ensaio")
public class Ensaio extends BasicBeanAudit {

	/**
	 * 
	 */
	private static final long serialVersionUID = 3153182579197582910L;
	private String nome;
	private List<TpAmostraEnsaio> tpAmostraEnsaios;
	private List<EnsaioKit> ensaioKits;
	private String legenda;
	private String conclusao;

	private Boolean selecionado;
	private Money valor;
	
	
	@Required
	@DescriptionProperty
	@Column(length = 50)
	@MaxLength(50)
	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	/**
	 * @return the tpAmostraEnsaios
	 */
	@OneToMany(mappedBy = "ensaio",fetch=FetchType.LAZY)
	@DisplayName("Tipos de Amostra")
	public List<TpAmostraEnsaio> getTpAmostraEnsaios() {
		return tpAmostraEnsaios;
	}

	/**
	 * @param tpAmostraEnsaios the tpAmostraEnsaios to set
	 */
	public void setTpAmostraEnsaios(
			List<TpAmostraEnsaio> tpAmostraEnsaios) {
		this.tpAmostraEnsaios = tpAmostraEnsaios;
	}

	/**
	 * @return the ensaioKits
	 */
	@OneToMany(mappedBy = "ensaio",fetch=FetchType.LAZY)
	@DisplayName("Ensaio Kit")
	public List<EnsaioKit> getEnsaioKits() {
		return ensaioKits;
	}

	/**
	 * @param ensaioKits the ensaioKits to set
	 */
	public void setEnsaioKits(List<EnsaioKit> ensaioKits) {
		this.ensaioKits = ensaioKits;
	}

	/**
	 * @return the selecionado
	 */
	@Transient
	public Boolean getSelecionado() {
		return selecionado;
	}

	/**
	 * @param selecionado the selecionado to set
	 */
	public void setSelecionado(Boolean selecionado) {
		this.selecionado = selecionado;
	}

	/**
	 * @return the valor
	 */
	@Transient
	public Money getValor() {
		return valor;
	}

	/**
	 * @param valor the valor to set
	 */
	public void setValor(Money valor) {
		this.valor = valor;
	}

	/**
	 * @return the legenda
	 */
	@Column(length = 250)
	@MaxLength(250)
	@DisplayName("Legenda")
	public String getLegenda() {
		return legenda;
	}

	/**
	 * @param legenda the legenda to set
	 */
	public void setLegenda(String legenda) {
		this.legenda = legenda;
	}

	/**
	 * @return the conclusao
	 */
	@Column(length = 250)
	@MaxLength(250)
	@DisplayName("Concluso")
	public String getConclusao() {
		return conclusao;
	}

	/**
	 * @param conclusao the conclusao to set
	 */
	public void setConclusao(String conclusao) {
		this.conclusao = conclusao;
	}

}
