package br.com.mss.labqp.cadastro.entity;

import java.util.List;

import javax.persistence.Column;
import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.nextframework.bean.annotation.DescriptionProperty;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.types.Telefone;
import org.nextframework.validation.annotation.Email;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBeanAudit;
import br.com.mss.labqp.geral.entity.Endereco;

@Entity
@Table(name = "inspetoria")
@DisplayName("Inspetoria")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_INSPETORIA_ID")
public class Inspetoria extends BasicBeanAudit {

	/**
	 * 
	 */
	private static final long serialVersionUID = 4365760617089865780L;
	/**
	 * 
	 */

	private String nome;
	private Telefone telefone;
	private String email;
	private Endereco endereco;
	private List<Cliente> clientes;
	

	@DescriptionProperty
	@Required
	@Column(length = 50)
	@MaxLength(50)
	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	/**
	 * @return the telefone
	 */
	@Column(length = 20)
	@MaxLength(20)
	public Telefone getTelefone() {
		return telefone;
	}

	/**
	 * @param telefone the telefone to set
	 */
	public void setTelefone(Telefone telefone) {
		this.telefone = telefone;
	}

	/**
	 * @return the email
	 */
	@Column(length = 50)
	@MaxLength(50)
	@Email
	public String getEmail() {
		return email;
	}

	/**
	 * @param email the email to set
	 */
	public void setEmail(String email) {
		this.email = email;
	}

	/**
	 * @return the endereco
	 */
	@Embedded
	public Endereco getEndereco() {
		return endereco;
	}

	/**
	 * @param endereco the endereco to set
	 */
	public void setEndereco(Endereco endereco) {
		this.endereco = endereco;
	}

	/**
	 * @return the clientes
	 */
	@OneToMany(mappedBy = "inspetoria")
	public List<Cliente> getClientes() {
		return clientes;
	}

	/**
	 * @param clientes the clientes to set
	 */
	public void setClientes(List<Cliente> clientes) {
		this.clientes = clientes;
	}

}
