package br.com.mss.labqp.cadastro.entity;

import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.nextframework.bean.annotation.DescriptionProperty;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBeanAudit;

@Entity
@Table(name = "tipoAmostra")
@DisplayName("Tipo de Amostra")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_TIPO_AMOSTRA_ID")
public class TipoAmostra extends BasicBeanAudit {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2876919721769031557L;

	private String nome;
	private List<TpAmostraEnsaio> tpAmostraEnsaios;
		
	/**
	 * @return the tpAmostraEnsaios
	 */
	@OneToMany(mappedBy = "tipoAmostra",fetch=FetchType.LAZY)
	@DisplayName("Ensaios")
	public List<TpAmostraEnsaio> getTpAmostraEnsaios() {
		return tpAmostraEnsaios;
	}

	/**
	 * @param tpAmostraEnsaios the tpAmostraEnsaios to set
	 */
	public void setTpAmostraEnsaios(
			List<TpAmostraEnsaio> tpAmostraEnsaios) {
		this.tpAmostraEnsaios = tpAmostraEnsaios;
	}

	@DescriptionProperty
	@Required
	@Column(length = 50)
	@MaxLength(50)
	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}


}
