package br.com.mss.labqp.cadastro.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.nextframework.bean.annotation.DescriptionProperty;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBeanAudit;
import br.com.mss.labqp.geral.FlagSimNaoEnum;
import br.com.mss.labqp.geral.TipoDocEnum;

@Entity
@Table(name = "tipoDocumento")
@DisplayName("Tipo de Documento")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_TIPO_DOCUMENTO_ID")
public class TipoDocumento extends BasicBeanAudit {


	/**
	 * 
	 */
	private static final long serialVersionUID = 2220300948399986100L;
	private String nome;
	private TipoDocEnum tipoDocEnum;
	private FlagSimNaoEnum ePlanoAmostragem;

	@DescriptionProperty
	@Required
	@Column(length = 50)
	@MaxLength(50)
	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	/**
	 * @return the tipoDocEnum
	 */
	@DisplayName("Tipo Documento")
	public TipoDocEnum getTipoDocEnum() {
		return tipoDocEnum;
	}

	/**
	 * @param tipoDocEnum the tipoDocEnum to set
	 */
	public void setTipoDocEnum(TipoDocEnum tipoDocEnum) {
		this.tipoDocEnum = tipoDocEnum;
	}

	/**
	 * @return the ePlanoAmostragem
	 */
	@DisplayName("Tipo Documento Plano Amostragem")
	public FlagSimNaoEnum getePlanoAmostragem() {
		return ePlanoAmostragem;
	}

	/**
	 * @param ePlanoAmostragem the ePlanoAmostragem to set
	 */
	public void setePlanoAmostragem(FlagSimNaoEnum ePlanoAmostragem) {
		this.ePlanoAmostragem = ePlanoAmostragem;
	}

}
