/**
 * 
 */
package br.com.mss.labqp.cadastro.entity;

import javax.persistence.Column;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.types.Cnpj;
import org.nextframework.types.Cpf;
import org.nextframework.validation.annotation.MaxLength;

import br.com.mss.labqp.FiltroListagemAudit;
import br.com.mss.labqp.geral.TipoPessoaEnum;

/**
 * 
 * @author mscheffer 21/10/2010
 * 
 */
public class VendedorFiltro extends FiltroListagemAudit {
	private String nome;
	private TipoPessoaEnum tipoPessoa;
	private Cnpj cnpj;
	private Cpf cpf;
	/**
	 * @return the nome
	 */
	@Column(length = 30)
	@MaxLength(50)
	public String getNome() {
		return nome;
	}

	/**
	 * @param nome
	 *            the nome to set
	 */
	public void setNome(String nome) {
		this.nome = nome;
	}

	/**
	 * @return the tipoPessoa
	 */
	@Enumerated(EnumType.ORDINAL)
	@DisplayName("Tipo de Pessoa")
	public TipoPessoaEnum getTipoPessoa() {
		return tipoPessoa;
	}

	/**
	 * @param tipoPessoa
	 *            the tipoPessoa to set
	 */
	public void setTipoPessoa(TipoPessoaEnum tipoPessoa) {
		this.tipoPessoa = tipoPessoa;
	}

	/**
	 * @return the cnpj
	 */
	@Column(length = 20)
	@MaxLength(20)
	public Cnpj getCnpj() {
		return cnpj;
	}

	/**
	 * @param cnpj the cnpj to set
	 */
	public void setCnpj(Cnpj cnpj) {
		this.cnpj = cnpj;
	}

	/**
	 * @return the cpf
	 */
	@Column(length = 14)
	@MaxLength(14)
	public Cpf getCpf() {
		return cpf;
	}

	/**
	 * @param cpf the cpf to set
	 */
	public void setCpf(Cpf cpf) {
		this.cpf = cpf;
	}

}
