package br.com.mss.labqp.controller;

import org.nextframework.controller.Controller;
import org.nextframework.controller.DefaultAction;
import org.nextframework.controller.MultiActionController;
import org.nextframework.core.standard.MessageType;
import org.nextframework.core.web.WebRequestContext;
import org.springframework.web.servlet.ModelAndView;

import br.com.mss.labqp.admin.dao.NextAuthorizationDAO;
import br.com.mss.labqp.admin.entity.Colaborador;

@Controller(path = "/principal/login")
public class LoginController extends MultiActionController {
	
	private static final String AFTER_LOGIN_GO_TO = "/admin/Index";

//	NextAuthorizationDAO authorizationDAO;

//	public void setAuthorizationDAO(NextAuthorizationDAO authorizationDAO) {
//		this.authorizationDAO = authorizationDAO;
//	}

	/**
	 * Action que envia para a pgina de login
	 */
	@DefaultAction
	public ModelAndView doPage(WebRequestContext request, Colaborador usuario) {
		return new ModelAndView("login", "usuario", usuario);
	}

	/**
	 * Efetua o login do usurio
	 */
	public ModelAndView doLogin(WebRequestContext request, Colaborador usuario) {
		String login = usuario.getLogin();
		// se foi passado o login na requisio, iremos verificar se o usurio
		// existe e a senha est correta
		System.out.println("login-> "+login);
		if (login != null) {
			// buscamos o usurio do banco pelo login
			System.out.println("Passo 1");
			
			NextAuthorizationDAO authorizationDAO = new NextAuthorizationDAO();
			Colaborador userByLogin =  (Colaborador) authorizationDAO.findUserByLogin(login);
			
			System.out.println("Passo 2->"+userByLogin.getLogin());
             
			// se o usurio existe e a senha est correta
			if (userByLogin != null
					&& userByLogin.getPassword().equals(usuario.getPassword())) {
				// Setando o atributo de seo USER fazemos o login do usurio
				// no sistema.
				System.out.println("Passo 3");

//				Calendar c = Calendar.getInstance();
//				SimpleDateFormat formataData = new SimpleDateFormat(
//						"dd/MM 's' HH:mm:ss ");
				//userByLogin.setHoraLogin(formataData.format(c.getTimeInMillis()));
				request.setUserAttribute("USER", userByLogin);
				System.out.println("Passo 4");

				// Limpamos o cache de permisses o menu.
				// O menu ser refeito levando em considerao as permisses do
				// usurio
				//request.setUserAttribute(MenuTag.MENU_CACHE_MAP, null);
				return new ModelAndView("redirect:" + AFTER_LOGIN_GO_TO);
			}

			// Se o login e/ou a senha no estiverem corretos, avisar o usurio
			request.addMessage("Login e/ou senha invlidos", MessageType.ERROR);
		}

		// limpar o campo senha, e enviar para a tela de login j que o processo
		// falhou
		//request.setUserAttribute(MenuTag.MENU_CACHE_MAP, null);
		request.getSession().invalidate();
		((Colaborador) usuario).setPassword(null);
		return doPage(request, usuario);
	}

	public ModelAndView encerrarSessao() {
		WebRequestContext request = getRequest();
		// Limpamos o cache de permisses o menu.
		// O menu ser refeito levando em considerao as permisses do
		// usurio
		Colaborador usuario = new Colaborador();
		//request.setUserAttribute(MenuTag.MENU_CACHE_MAP, null);
		request.getSession().invalidate();
		return doPage(request, usuario);
	}

}
