package br.com.mss.labqp.controller.modulo;

import org.nextframework.authorization.crud.CrudAuthorizationModule;
import org.nextframework.controller.Controller;
import org.nextframework.controller.crud.CrudController;
import org.springframework.validation.BindException;

import br.com.mss.labqp.cadastro.entity.Cliente;
import br.com.mss.labqp.cadastro.entity.ClienteFiltro;
import br.com.mss.labqp.cadastro.service.ClienteService;
import br.com.mss.labqp.geral.TipoPessoaEnum;

@Controller(path = "/cadastro/crud/Cliente", authorizationModule = CrudAuthorizationModule.class)
public class ClienteCrud extends
CrudController<ClienteFiltro, Cliente, Cliente> {
    
	ClienteService clienteService;
	
	/**
	 * @param clienteService the clienteService to set
	 */
	public void setClienteService(ClienteService clienteService) {
		this.clienteService = clienteService;
	}
	
	@Override
	protected void validate(Object obj, BindException errors, String acao) {
		if ("salvar".equals(acao)) {
			Cliente cliente = (Cliente) obj;
			if (cliente.getTipoPessoa() == TipoPessoaEnum.JURIDICA) {
				if (cliente.getCpf() != null) {
					cliente.setCpf(null);
					errors.reject("teste",
							"O campo a ser preenchido para pessoa jurdica  o CNPJ!");
				}
				if (cliente.getCnpj() != null && cliente.getId() == null) {
					if (clienteService.findByTipoPessoa(TipoPessoaEnum.JURIDICA, cliente.getCnpj().getValue()) ) { 
						errors.reject("teste",
								"J existe um cliente cadastrado com esse CNPJ!");
					}
				}
			}
			if (cliente.getTipoPessoa() == TipoPessoaEnum.FISICA) {
				if (cliente.getCnpj() != null) {
					cliente.setCnpj(null);
					errors.reject("teste",
						"O campo a ser preenchido para pessoa fsica  o Cpf!");
				}
				if (cliente.getCpf() != null && cliente.getId() == null) {
					if (clienteService.findByTipoPessoa(TipoPessoaEnum.FISICA, cliente.getCpf().getValue()) ) { 
						errors.reject("teste",
								"J existe um cliente cadastrado com esse CPF!");
					}
				}
				
			}
		}
	}


}
