package br.com.mss.labqp.controller.modulo;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.nextframework.authorization.crud.CrudAuthorizationModule;
import org.nextframework.controller.Controller;
import org.nextframework.controller.NoActionHandlerException;
import org.nextframework.controller.crud.CrudController;
import org.nextframework.core.web.WebRequestContext;
import org.nextframework.view.ajax.View;
import org.springframework.web.servlet.ModelAndView;

import br.com.mss.labqp.cadastro.entity.Ensaio;
import br.com.mss.labqp.cadastro.entity.TpAmostraEnsaio;
import br.com.mss.labqp.cadastro.service.ClienteService;
import br.com.mss.labqp.cadastro.service.EnsaioService;
import br.com.mss.labqp.cadastro.service.TipoAmostraService;
import br.com.mss.labqp.cadastro.service.TpAmostraEnsaioService;
import br.com.mss.labqp.geral.SituacaoRequisicaoEnum;
import br.com.mss.labqp.orcamento.entity.ItemOrcamento;
import br.com.mss.labqp.orcamento.entity.ListaEnsaio;
import br.com.mss.labqp.orcamento.entity.Orcamento;
import br.com.mss.labqp.orcamento.entity.OrcamentoFiltro;
import br.com.mss.labqp.orcamento.entity.OrcamentoTipoAmostra;
import br.com.mss.labqp.orcamento.service.ItemOrcamentoService;
import br.com.mss.labqp.orcamento.service.OrcamentoTipoAmostraService;
import br.com.mss.labqp.requisicao.entity.ItemRequisicaoAnalise;
import br.com.mss.labqp.requisicao.entity.RequisicaoAnalise;
import br.com.mss.labqp.requisicao.service.RequisicaoAnaliseService;

@Controller(path = "/orcamento/crud/Orcamento", authorizationModule = CrudAuthorizationModule.class)
public class OrcamentoCrud extends
		CrudController<OrcamentoFiltro, Orcamento, Orcamento> {

	TipoAmostraService tipoAmostraService;
	EnsaioService ensaioService;
	ClienteService clienteService;
	OrcamentoTipoAmostraService orcamentoTipoAmostraService;
	ItemOrcamentoService itemOrcamentoService;
	TpAmostraEnsaioService tpAmostraEnsaioService;
	RequisicaoAnaliseService requisicaoAnaliseService;

	/**
	 * @param requisicaoAnaliseService the requisicaoAnaliseService to set
	 */
	public void setRequisicaoAnaliseService(
			RequisicaoAnaliseService requisicaoAnaliseService) {
		this.requisicaoAnaliseService = requisicaoAnaliseService;
	}

	/**
	 * @param ensaioService the ensaioService to set
	 */
	public void setEnsaioService(
			EnsaioService ensaioService) {
		this.ensaioService = ensaioService;
	}

	/**
	 * @param tipoAmostraService the tipoAmostraService to set
	 */
	public void setTipoAmostraService(TipoAmostraService tipoAmostraService) {
		this.tipoAmostraService = tipoAmostraService;
	}

	/**
	 * @param clienteService
	 *            the clienteService to set
	 */
	public void setClienteService(ClienteService clienteService) {
		this.clienteService = clienteService;
	}

	/**
	 * @param orcamentoTipoAmostra the orcamentoTipoAmostra to set
	 */
	public void setOrcamentoTipoAmostraService(OrcamentoTipoAmostraService orcamentoTipoAmostraService) {
		this.orcamentoTipoAmostraService = orcamentoTipoAmostraService;
	}

	
	/**
	 * @param itemOrcamentoService the itemOrcamentoService to set
	 */
	public void setItemOrcamentoService(ItemOrcamentoService itemOrcamentoService) {
		this.itemOrcamentoService = itemOrcamentoService;
	}

	/**
	 * @param tpAmostraEnsaioService the tpAmostraEnsaioService to set
	 */
	public void setTpAmostraEnsaioService(
			TpAmostraEnsaioService tpAmostraEnsaioService) {
		this.tpAmostraEnsaioService = tpAmostraEnsaioService;
	}

	public String gravaItensOrcamento(WebRequestContext request, ListaEnsaio listaEnsaio ) {
		String id = getParameter("id");
		if (id != null && id != "") {
			OrcamentoTipoAmostra orcTpAmos = new OrcamentoTipoAmostra();
			orcTpAmos.setId(new Long(id));
			orcTpAmos = orcamentoTipoAmostraService.load(orcTpAmos);
			itemOrcamentoService.gravaItensOrcamento(listaEnsaio.getEnsaios(), orcTpAmos);
		}	
	    
		String pagRetorno = "crud/orcamentoItens";
		setUserAttribute("listaEnsaio", listaEnsaio);
		
		request.addMessage("Ensaios de Anlise salvos com sucesso!");
		return pagRetorno;
	}
	
	public String getParAnaliseByTipoAmostra() {
		String id = getParameter("id");
		String orcamentoId;
		String pagRetorno = "crud/orcamentoEntrada";
		if (id != null && id != "") {
			OrcamentoTipoAmostra orcTpAmos = new OrcamentoTipoAmostra();
			orcTpAmos.setId(new Long(id));
			orcTpAmos = orcamentoTipoAmostraService.load(orcTpAmos);
			orcamentoId = orcTpAmos.getOrcamento().getId().toString();
			
			if (orcTpAmos != null && orcTpAmos.getTipoAmostra() != null) {
				
				List<TpAmostraEnsaio> tpAmostraEnsaios = tpAmostraEnsaioService.findBy(orcTpAmos.getTipoAmostra(),false,"");
				
				List<Ensaio> ensaiosList = new ArrayList<Ensaio>();
				if (tpAmostraEnsaios != null && tpAmostraEnsaios.size() > 0) {
					for (TpAmostraEnsaio tpAmostraEnsaio : tpAmostraEnsaios) {
						Ensaio ea = ensaioService.load(tpAmostraEnsaio.getEnsaio());
						ea.setValor(tpAmostraEnsaio.getValor());
						ensaiosList.add(ea);
					}
				}
				
				List<ItemOrcamento> itemOrcamentos = itemOrcamentoService.findBy(orcTpAmos,false,"");
				if (itemOrcamentos != null && itemOrcamentos.size() > 0) {
					for (ItemOrcamento io : itemOrcamentos) {
						Long idSel = io.getEnsaio().getId();
						for (Ensaio paList : ensaiosList) {
							if (paList.getId().equals(idSel)) {
								paList.setValor(io.getValor());
								paList.setSelecionado(true);
								break;
							}
						}
					}
				}
				ListaEnsaio listaEnsaio = new ListaEnsaio();
				listaEnsaio.setEnsaiosAnalise(ensaiosList);
				setUserAttribute("listaEnsaio", listaEnsaio);
				setUserAttribute("orcamentoId",orcamentoId);
				setUserAttribute("orcTipoAmostraId", id);
				setUserAttribute("orcTpAmos",orcTpAmos);
				pagRetorno = "crud/orcamentoItens";
			}
		} 
		return pagRetorno;		
	}
	
	public void gerarRequisicaoTipoAmostra() {
		String id = getParameter("id");
		String msgRetorno = "Tipo de Amostra no encontrado! Talvez tenha que salvar o tipo de amostra primeiro. Favor verificar...";
		if (id != null && id != "") {
			msgRetorno = "Requisio gerada com sucesso!";
			geraReqOrcTipoAmostra(id);
		}
		View.getCurrent().alert(msgRetorno);
	}

	public void gerarRequisicaoOrcamento() {
		String id = getParameter("id");
		String msgRetorno = "Oramento no encontrado! Talvez tenha que salvar o orcamento primeiro. Favor verificar...";
		Orcamento orc = new Orcamento();
		if (id != null && id != "") {
			msgRetorno = "Requisio(es) gerada(s) com sucesso!";
			orc.setId(new Long(id));
			
			List<OrcamentoTipoAmostra> orcTAList = orcamentoTipoAmostraService.findBy(orc,false, "");
			if (orcTAList != null && orcTAList.size() > 0) {
				for (OrcamentoTipoAmostra orcamentoTipoAmostra : orcTAList) {
					geraReqOrcTipoAmostra(orcamentoTipoAmostra.getId().toString());
				}
			}
		}
		View.getCurrent().alert(msgRetorno);
	}
	
	
	private void geraReqOrcTipoAmostra(String id) {
		OrcamentoTipoAmostra orcTpAmos = new OrcamentoTipoAmostra();
		orcTpAmos.setId(new Long(id));
		orcTpAmos = orcamentoTipoAmostraService.load(orcTpAmos);
		
		Orcamento orc = genericService.load(orcTpAmos.getOrcamento());
		
		RequisicaoAnalise ra = new RequisicaoAnalise();
		ra.setCliente(orc.getCliente());
		ra.setTipoAmostra(orcTpAmos.getTipoAmostra());
		
		List<ItemRequisicaoAnalise> irList = new ArrayList<ItemRequisicaoAnalise>();
		ItemRequisicaoAnalise ir;
		List<ItemOrcamento> ioList = itemOrcamentoService.findBy(orcTpAmos,false,"");
		List<TpAmostraEnsaio> tpaeaList =	tpAmostraEnsaioService.findBy(orcTpAmos.getTipoAmostra(),false,"");
		for (ItemOrcamento itemOrcamento : ioList) {
			ir = new ItemRequisicaoAnalise();
			ir.setEnsaio(itemOrcamento.getEnsaio());
			ir.setValor(itemOrcamento.getValor());
			
			if (tpaeaList != null && tpaeaList.size() > 0) {
				
				for (TpAmostraEnsaio tpAmostraEnsaio : tpaeaList) {
					if (tpAmostraEnsaio.getEnsaio().getId().equals(itemOrcamento.getEnsaio().getId())) {
						ir.setMetodoAnalitico(tpAmostraEnsaio.getMetodoAnalitico());
						ir.setUnidade(tpAmostraEnsaio.getUnidade());
						break;
					}
				}
			}	
			irList.add(ir);
		}
		ra.setSituacaoRequisicaoEnum(SituacaoRequisicaoEnum.AGUARDANDO_RESULTADOS);
		ra.setItensRequisicaoAnalise(irList);
//		ra.setOrcamento(orcTpAmos.getOrcamento());
		ra.setOrcamentoTipoAmostra(orcTpAmos);
		requisicaoAnaliseService.saveOrUpdate(ra);
	}
	
	@Override
	protected ModelAndView handleRequestInternal(HttpServletRequest request,
			HttpServletResponse response) throws Exception {
	      try{
		         return super.handleRequestInternal(request, response);
		      }catch(NoActionHandlerException exception){ //se nao achar a action
		         return sendRedirectToAction(null); //volta para a action default
		      }
	}
}