package br.com.mss.labqp.controller.modulo;

import org.nextframework.authorization.crud.CrudAuthorizationModule;
import org.nextframework.controller.Controller;
import org.nextframework.controller.crud.CrudController;
import org.springframework.validation.BindException;

import br.com.mss.labqp.cadastro.entity.Vendedor;
import br.com.mss.labqp.cadastro.entity.VendedorFiltro;
import br.com.mss.labqp.cadastro.service.VendedorService;
import br.com.mss.labqp.geral.TipoPessoaEnum;

@Controller(path = "/cadastro/crud/Vendedor", authorizationModule = CrudAuthorizationModule.class)
public class VendedorCrud extends
CrudController<VendedorFiltro, Vendedor, Vendedor> {
    
	VendedorService vendedorService;
	
	/**
	 * @param vendedorService the vendedorService to set
	 */
	public void setVendedorService(VendedorService vendedorService) {
		this.vendedorService = vendedorService;
	}
	
	@Override
	protected void validate(Object obj, BindException errors, String acao) {
		if ("salvar".equals(acao)) {
			Vendedor vendedor = (Vendedor) obj;
			if (vendedor.getTipoPessoa() == TipoPessoaEnum.JURIDICA) {
				if (vendedor.getCpf() != null) {
					vendedor.setCpf(null);
					errors.reject("teste",
							"O campo a ser preenchido para pessoa jurdica  o CNPJ!");
				}
				if (vendedor.getCnpj() != null && vendedor.getId() == null) {
					if (vendedorService.findByTipoPessoa(TipoPessoaEnum.JURIDICA, vendedor.getCnpj().getValue()) ) { 
						errors.reject("teste",
								"J existe um vendedor cadastrado com esse CNPJ!");
					}	
				}
			}
			if (vendedor.getTipoPessoa() == TipoPessoaEnum.FISICA) {
				if (vendedor.getCnpj() != null) {
					vendedor.setCnpj(null);
					errors.reject("teste",
						"O campo a ser preenchido para pessoa fsica  o Cpf!");
				}
				if (vendedor.getCpf() != null && vendedor.getId() == null) {
					if (vendedorService.findByTipoPessoa(TipoPessoaEnum.FISICA, vendedor.getCpf().getValue()) ) { 
						errors.reject("teste",
								"J existe um vendedor cadastrado com esse CPF!");
					}
				}
				
			}
		}
	}


}
