package br.com.mss.labqp.financeiro.entity;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.springframework.format.annotation.DateTimeFormat;

import br.com.mss.labqp.FiltroListagemAudit;
import br.com.mss.labqp.cadastro.entity.Cliente;
import br.com.mss.labqp.geral.SituacaoDocEnum;
import br.com.mss.labqp.geral.TipoDocEnum;

public class DocumentoFiltro extends FiltroListagemAudit {

	private Long id;
	private Date dataProcessamento;
	private Date dataEmissao;
	private Cliente cliente;
	private String observacao;
	private String numeroNf;
	private TipoDocEnum tipoDocEnum;
	private SituacaoDocEnum situacaoDocEnum;

	
	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}
	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}
	/**
	 * @return the datahoraColeta
	 */
	@DateTimeFormat()
	@Temporal(TemporalType.DATE)
	public Date getDataEmissao() {
		return dataEmissao;
	}
	/**
	 * @param datahoraColeta the datahoraColeta to set
	 */
	public void setDataEmissao(Date dataEmissao) {
		this.dataEmissao = dataEmissao;
	}
	/**
	 * @return the cliente
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	public Cliente getCliente() {
		return cliente;
	}
	/**
	 * @param cliente the cliente to set
	 */
	public void setCliente(Cliente cliente) {
		this.cliente = cliente;
	}
	/**
	 * @return the observacao
	 */
	@Column(length = 150)
	@MaxLength(150)
	@DisplayName("Observao")
	public String getObservacao() {
		return observacao;
	}
	/**
	 * @param observacao the observacao to set
	 */
	public void setObservacao(String observacao) {
		this.observacao = observacao;
	}
	/**
	 * @return the numeroNf
	 */
	@DisplayName("Nmero NF")
	public String getNumeroNf() {
		return numeroNf;
	}
	/**
	 * @param numeroNf the numeroNf to set
	 */
	public void setNumeroNf(String numeroNf) {
		this.numeroNf = numeroNf;
	}
	/**
	 * @return the situacaoDocEnum
	 */
	@DisplayName("Situaao Documento")
	public SituacaoDocEnum getSituacaoDocEnum() {
		return situacaoDocEnum;
	}
	/**
	 * @param situacaoDocEnum the situacaoDocEnum to set
	 */
	public void setSituacaoDocEnum(SituacaoDocEnum situacaoDocEnum) {
		this.situacaoDocEnum = situacaoDocEnum;
	}
	/**
	 * @return the tipoDocEnum
	 */
	@DisplayName("Tipo Documento")
	public TipoDocEnum getTipoDocEnum() {
		return tipoDocEnum;
	}
	/**
	 * @param tipoDocEnum the tipoDocEnum to set
	 */
	public void setTipoDocEnum(TipoDocEnum tipoDocEnum) {
		this.tipoDocEnum = tipoDocEnum;
	}
	/**
	 * @return the dataProcessamento
	 */
	@DateTimeFormat()
	@Temporal(TemporalType.DATE)
	public Date getDataProcessamento() {
		return dataProcessamento;
	}
	/**
	 * @param dataProcessamento the dataProcessamento to set
	 */
	public void setDataProcessamento(Date dataProcessamento) {
		this.dataProcessamento = dataProcessamento;
	}
}
