package br.com.mss.labqp.financeiro.entity;

import java.math.BigDecimal;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.hibernate.annotations.Formula;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.types.Money;
import org.nextframework.validation.annotation.Required;
import org.springframework.format.annotation.NumberFormat;
import org.springframework.format.annotation.NumberFormat.Style;

import br.com.mss.labqp.BasicBean;
import br.com.mss.labqp.geral.ImpostoEnum;

@Entity
@Table(name = "impostoDocumento")
@DisplayName("Impostos do Documento")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_IMPOSTO_DOCUMENTO_ID")
public class ImpostoDocumento extends BasicBean {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3389388365699823981L;
	/**
	 * 
	 */
	private Documento documento;
	private ImpostoEnum imposto;
	private BigDecimal percentual;
	private Money valor;
	/**
	 * @return the documento
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	@Required
	public Documento getDocumento() {
		return documento;
	}
	/**
	 * @param documento the documento to set
	 */
	public void setDocumento(Documento documento) {
		this.documento = documento;
	}
	/**
	 * @return the imposto
	 */
	public ImpostoEnum getImposto() {
		return imposto;
	}
	/**
	 * @param imposto the imposto to set
	 */
	public void setImposto(ImpostoEnum imposto) {
		this.imposto = imposto;
	}
	/**
	 * @return the percentual
	 */
	@Column(precision=6,scale=2)
	@NumberFormat(style = Style.PERCENT)
	@DisplayName("%")
	public BigDecimal getPercentual() {
		return percentual;
	}
	/**
	 * @param percentual the percentual to set
	 */
	public void setPercentual(BigDecimal percentual) {
		this.percentual = percentual;
	}
	/**
	 * @return the valor
	@Formula("(select sum(i.valor) from itemDocumento i where i.documento_id = id) ")

	 */
	
	@Formula("(((select sum(i.valor) from itemDocumento i where i.documento_id = documento_id) * percentual)/100)")
	public Money getValor() {
		return valor;
	}
	/**
	 * @param valor the valor to set
	 */
	public void setValor(Money valor) {
		this.valor = valor;
	}
}	
