package br.com.mss.labqp.financeiro.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.types.Money;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBean;
import br.com.mss.labqp.cadastro.entity.TipoDocumento;

@Entity
@Table(name = "itemDocumento")
@DisplayName("Item Documento")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_ITEM_DOCUMENTO_ID")
public class ItemDocumento extends BasicBean {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3389388365699823981L;
	/**
	 * 
	 */
	private Documento documento;
	private Long idDoc;
	private String descricao;
	private TipoDocumento tipoDocumento;
	private Money valor;
	/**
	 * @return the documento
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	@Required
	public Documento getDocumento() {
		return documento;
	}
	/**
	 * @param documento the documento to set
	 */
	public void setDocumento(Documento documento) {
		this.documento = documento;
	}
	/**
	 * @return the idDoc
	 */
	public Long getIdDoc() {
		return idDoc;
	}
	/**
	 * @param idDoc the idDoc to set
	 */
	public void setIdDoc(Long idDoc) {
		this.idDoc = idDoc;
	}
	/**
	 * @return the descricao
	 */
	@Column(length = 50)
	@MaxLength(50)
	@DisplayName("Descrio")
	public String getDescricao() {
		return descricao;
	}
	/**
	 * @param descricao the descricao to set
	 */
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}
	/**
	 * @return the tipoDocumento
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	@Required
	@DisplayName("Tipo Documento")
	public TipoDocumento getTipoDocumento() {
		return tipoDocumento;
	}
	/**
	 * @param tipoDocumento the tipoDocumento to set
	 */
	public void setTipoDocumento(TipoDocumento tipoDocumento) {
		this.tipoDocumento = tipoDocumento;
	}
	/**
	 * @return the valor
	 */
	public Money getValor() {
		return valor;
	}
	/**
	 * @param valor the valor to set
	 */
	public void setValor(Money valor) {
		this.valor = valor;
	}
}	
