package br.com.mss.labqp.financeiro.entity;

import java.util.Date;

import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.nextframework.bean.annotation.DisplayName;
import org.springframework.format.annotation.DateTimeFormat;

import br.com.mss.labqp.FiltroListagemAudit;
import br.com.mss.labqp.cadastro.entity.Cliente;
import br.com.mss.labqp.geral.SituacaoDocEnum;
import br.com.mss.labqp.geral.TipoDocEnum;


public class ParcelaFiltro extends FiltroListagemAudit {
	
	private Long id;
	private Documento documento;
	private TipoDocEnum tipoDocEnum;
	private SituacaoDocEnum situacaoDocEnum;
	private Cliente cliente;
	private Short parcelaSeq;
	private Date dataProcIni;
	private Date dataProcFim;
	private Date dataVencIni = new Date();
	private Date dataVencFim = new Date();
	private Date dataPagIni;
	private Date dataPagFim;
	/**
	 * @return the documento
	 */
	public Documento getDocumento() {
		return documento;
	}
	/**
	 * @param documento the documento to set
	 */
	public void setDocumento(Documento documento) {
		this.documento = documento;
	}
	
	/**
	 * @return the parcelaSeq
	 */
	public Short getParcelaSeq() {
		return parcelaSeq;
	}

	/**
	 * @param parcelaSeq
	 *            the parcelaSeq to set
	 */
	public void setParcelaSeq(Short parcelaSeq) {
		this.parcelaSeq = parcelaSeq;
	}

	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}
	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}
	/**
	 * @return the tipoDocEnum
	 */
	@DisplayName("Tipo Documento")
	public TipoDocEnum getTipoDocEnum() {
		return tipoDocEnum;
	}
	/**
	 * @param tipoDocEnum the tipoDocEnum to set
	 */
	public void setTipoDocEnum(TipoDocEnum tipoDocEnum) {
		this.tipoDocEnum = tipoDocEnum;
	}
	/**
	 * @return the situacaoDocEnum
	 */
	@DisplayName("Situao Documento")
	public SituacaoDocEnum getSituacaoDocEnum() {
		return situacaoDocEnum;
	}
	/**
	 * @param situacaoDocEnum the situacaoDocEnum to set
	 */
	public void setSituacaoDocEnum(SituacaoDocEnum situacaoDocEnum) {
		this.situacaoDocEnum = situacaoDocEnum;
	}
	/**
	 * @return the dataProcIni
	 */
	@DateTimeFormat
	@Temporal(TemporalType.DATE)
	@DisplayName("Data Processamento Inicial")
	public Date getDataProcIni() {
		return dataProcIni;
	}

	/**
	 * @param dataProcIni
	 *            the dataProcIni to set
	 */
	public void setDataProcIni(Date dataProcIni) {
		this.dataProcIni = dataProcIni;
	}

	/**
	 * @return the dataProcFim
	 */
	@DateTimeFormat
	@Temporal(TemporalType.DATE)
	@DisplayName("Data Processamento Final")
	public Date getDataProcFim() {
		return dataProcFim;
	}

	/**
	 * @param dataProcFim
	 *            the dataProcFim to set
	 */
	public void setDataProcFim(Date dataProcFim) {
		this.dataProcFim = dataProcFim;
	}

	/**
	 * @return the dataVencIni
	 */
	@DateTimeFormat
	@Temporal(TemporalType.DATE)
	@DisplayName("Data Vencimento Inicial")
	public Date getDataVencIni() {
		return dataVencIni;
	}

	/**
	 * @param dataVencIni
	 *            the dataVencIni to set
	 */
	public void setDataVencIni(Date dataVencIni) {
		this.dataVencIni = dataVencIni;
	}

	/**
	 * @return the dataVencFim
	 */
	@DateTimeFormat
	@Temporal(TemporalType.DATE)
	@DisplayName("Data Vencimento Final")
	public Date getDataVencFim() {
		return dataVencFim;
	}

	/**
	 * @param dataVencFim
	 *            the dataVencFim to set
	 */
	public void setDataVencFim(Date dataVencFim) {
		this.dataVencFim = dataVencFim;
	}

	/**
	 * @return the dataPagIni
	 */
	@DateTimeFormat
	@Temporal(TemporalType.DATE)
	@DisplayName("Data Pagamento Inicial")
	public Date getDataPagIni() {
		return dataPagIni;
	}

	/**
	 * @param dataPagIni
	 *            the dataPagIni to set
	 */
	public void setDataPagIni(Date dataPagIni) {
		this.dataPagIni = dataPagIni;
	}

	/**
	 * @return the dataPagFim
	 */
	@DateTimeFormat
	@Temporal(TemporalType.DATE)
	@DisplayName("Data Final")
	public Date getDataPagFim() {
		return dataPagFim;
	}

	/**
	 * @param dataPagFim
	 *            the dataPagFim to set
	 */
	public void setDataPagFim(Date dataPagFim) {
		this.dataPagFim = dataPagFim;
	}
	/**
	 * @return the cliente
	 */
	public Cliente getCliente() {
		return cliente;
	}
	/**
	 * @param cliente the cliente to set
	 */
	public void setCliente(Cliente cliente) {
		this.cliente = cliente;
	}

}
