package br.com.mss.labqp.geral.entity;

import javax.persistence.Column;
import javax.persistence.Embeddable;

import org.hibernate.annotations.Formula;
import org.nextframework.bean.annotation.DescriptionProperty;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.types.Cep;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;


@Embeddable
public class Endereco {

	private String logradouro;
	private String numero;
	private String complemento;
	private Cep cep;
	private String bairro;
	private String cidade;
	private String pontoReferencia;
	private String uf;
	private String enderecoStr;

	@Required
	@Column(length = 60)
	@MaxLength(60)
	@DescriptionProperty
	public String getLogradouro() {
		return logradouro;
	}

	public void setLogradouro(String logradouro) {
		this.logradouro = logradouro;
	}

	@Column(length = 10)
	@MaxLength(10)
	@DisplayName("Nmero")
	public String getNumero() {
		return numero;
	}

	public void setNumero(String numero) {
		this.numero = numero;
	}

	@Column(length = 30)
	@MaxLength(30)
	public String getComplemento() {
		return complemento;
	}

	public void setComplemento(String complemento) {
		this.complemento = complemento;
	}

	@Column(length = 9)
	@MaxLength(9)
	public Cep getCep() {
		return cep;
	}

	public void setCep(Cep cep) {
		this.cep = cep;
	}

	@Column(length = 30)
	@MaxLength(30)
	public String getBairro() {
		return bairro;
	}

	public void setBairro(String bairro) {
		this.bairro = bairro;
	}

	@Column(length = 60)
	@MaxLength(60)
	public String getCidade() {
		return cidade;
	}

	public void setCidade(String cidade) {
		this.cidade = cidade;
	}

	@Column(length = 60)
	@MaxLength(60)
	@DisplayName("Ponto de Referncia")
	public String getPontoReferencia() {
		return pontoReferencia;
	}

	public void setPontoReferencia(String pontoReferencia) {
		this.pontoReferencia = pontoReferencia;
	}

	@Column(length = 2)
	@MaxLength(2)
	public String getUf() {
		return uf;
	}

	public void setUf(String uf) {
		this.uf = uf;
	}

	/**
	 * @return the enderecoStr
	 */
	@Formula("(logradouro || ', ' || numero || ' ' || complemento || ', ' || bairro || '-' || cidade || '/' || uf)")
	public String getEnderecoStr() {
		return enderecoStr;
	}

	/**
	 * @param enderecoStr the enderecoStr to set
	 */
	public void setEnderecoStr(String enderecoStr) {
		this.enderecoStr = enderecoStr;
	}

}
