package br.com.mss.labqp.orcamento.dao;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.FetchMode;
import org.hibernate.criterion.ProjectionList;
import org.hibernate.criterion.Projections;
import org.hibernate.criterion.Restrictions;
import org.hibernate.transform.Transformers;
import org.nextframework.persistence.GenericDAO;
import org.nextframework.persistence.QueryBuilder;

import br.com.mss.labqp.orcamento.entity.ItemOrcamento;
import br.com.mss.labqp.orcamento.entity.OrcamentoDoc;
import br.com.mss.labqp.orcamento.entity.OrcamentoFiltro;

public class ItemOrcamentoDAO extends GenericDAO<ItemOrcamento> {

	public List<OrcamentoDoc> orcamentoDoc(OrcamentoFiltro filtro) {
		
		Criteria c = getSession().createCriteria(ItemOrcamento.class,"io");
		c.createAlias("orcTipoAmostra", "orcTpAmo");
		c.createAlias("orcTipoAmostra.tipoAmostra", "tpAmo");
		c.createAlias("orcTipoAmostra.orcamento", "orc");
		c.setFetchMode("orcTpAmo", FetchMode.JOIN);
		c.setFetchMode("tpAmo", FetchMode.JOIN);
		c.setFetchMode("orc", FetchMode.JOIN);
		ProjectionList pl = Projections.projectionList();
		pl.add(Projections.groupProperty("io.orcTipoAmostra").as("orcamentoTipoAmostra"));
		pl.add(Projections.groupProperty("orcTpAmo.tipoAmostra").as("tipoAmostra"));
		pl.add(Projections.groupProperty("orcTpAmo.orcamento").as("orcamento"));
		pl.add(Projections.sum("valor").as("vlrOrcamentoTipoAmostra"));
	 
		c.setProjection(pl);
	    c.add(Restrictions.eq("orcTpAmo.orcamento.id", filtro.getId()));
	    c.setResultTransformer(Transformers.aliasToBean(OrcamentoDoc.class));
		
		@SuppressWarnings("unchecked")
		List<OrcamentoDoc> lista = c.list();
		return lista;
	}
	
	public List<ItemOrcamento> itens(Long orcTipoAmostraId) {
		QueryBuilder<ItemOrcamento> query = query();
		query.joinFetch("itemOrcamento.orcTipoAmostra");
		query.joinFetch("itemOrcamento.parametroAnalise");
		query.joinFetch("itemOrcamento.orcTipoAmostra.orcamento");
		query.where("itemOrcamento.orcTipoAmostra.id = ? ", orcTipoAmostraId);
		query.orderBy("itemOrcamento.parametroAnalise.nome");
		return query.list();
	}

	

}
