package br.com.mss.labqp.orcamento.dao;

import java.util.Date;

import org.nextframework.controller.crud.FiltroListagem;
import org.nextframework.persistence.QueryBuilder;
import org.nextframework.persistence.SaveOrUpdateStrategy;

import br.com.mss.labqp.GenericAuditDAO;
import br.com.mss.labqp.geral.FiltroExcluidoEnum;
import br.com.mss.labqp.orcamento.entity.Orcamento;
import br.com.mss.labqp.orcamento.entity.OrcamentoFiltro;

public class OrcamentoDAO extends GenericAuditDAO<Orcamento> {

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateListagemQuery(org.nextframework.persistence.QueryBuilder, org.nextframework.controller.crud.FiltroListagem)
	 */
	@Override
	public void updateListagemQuery(QueryBuilder<Orcamento> query,
			FiltroListagem _filtro) {
		
		query.joinFetch("orcamento.cliente");
		OrcamentoFiltro filtro = (OrcamentoFiltro) _filtro;
		Date[] datas = { filtro.getDataI(), filtro.getDataF() };
		query.where("orcamento.id = ?", filtro.getId());
		query.where("orcamento.cliente = ?", filtro.getCliente());
		query.where("orcamento.data between ? and ?", datas);
		if (filtro.getFiltroExcluido() != null) {
			if (filtro.getFiltroExcluido() == FiltroExcluidoEnum.SIM)
				query.where("orcamento.dataExc is not null");
			else
				query.where("orcamento.dataExc is null");

		}
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateSaveOrUpdate(org.nextframework.persistence.SaveOrUpdateStrategy)
	 */
	@Override
	public void updateSaveOrUpdate(SaveOrUpdateStrategy save) {
		save.saveOrUpdateManaged("tiposAmostras");
		save.saveOrUpdateManaged("itensAdicionaisOrcamentos");
		super.updateSaveOrUpdate(save);
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateEntradaQuery(org.nextframework.persistence.QueryBuilder)
	 */
	@Override
	public void updateEntradaQuery(QueryBuilder<Orcamento> query) {
		query.joinFetch("orcamento.cliente");
		query.fetchCollection("tiposAmostras");
		query.fetchCollection("itensAdicionaisOrcamentos");
		super.updateEntradaQuery(query);
	}
	
	
}
