package br.com.mss.labqp.orcamento.entity;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.types.Money;

import br.com.mss.labqp.BasicBean;
import br.com.mss.labqp.cadastro.entity.Ensaio;

@Entity
@Table(name = "itemOrcamento")
@DisplayName("Itens do Oramento")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_ITEM_ORCAMENTO_ID")
public class ItemOrcamento extends BasicBean {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6905957512086308119L;
	private OrcamentoTipoAmostra orcTipoAmostra;
	private Ensaio ensaio;
	private Money valor;
	
	/**
	 * @return the orcTipoAmostra
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	public OrcamentoTipoAmostra getOrcTipoAmostra() {
		return orcTipoAmostra;
	}
	
	/**
	 * @param orcTipoAmostra the orcTipoAmostra to set
	 */
	public void setOrcTipoAmostra(OrcamentoTipoAmostra orcTipoAmostra) {
		this.orcTipoAmostra = orcTipoAmostra;
	}
	
	/**
	 * @return the ensaio
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	public Ensaio getEnsaio() {
		return ensaio;
	}
	/**
	 * @param ensaio the ensaio to set
	 */
	public void setEnsaio(Ensaio ensaio) {
		this.ensaio = ensaio;
	}
	/**
	 * @return the valor
	 */
	public Money getValor() {
		return valor;
	}
	/**
	 * @param valor the valor to set
	 */
	public void setValor(Money valor) {
		this.valor = valor;
	}

}
