package br.com.mss.labqp.orcamento.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.nextframework.bean.annotation.DescriptionProperty;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.types.Money;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBean;

@Entity
@Table(name = "itensAdicionaisOrcamento")
@DisplayName("Itens adicionais do Oramento")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_ITENS_ADIC_ORC_ID")
public class ItensAdicionaisOrcamento extends BasicBean {

	/**
	 * 
	 */
	private static final long serialVersionUID = 3075764708318361604L;
	/**
	 * 
	 */
	private String descricaoItem;
	private Money valor;
	private Orcamento orcamento;
	
	/**
	 * @return the descricaoItem
	 */
	@DisplayName("Descrio do Item")
	@Column(length=50)
	@MaxLength(50)
	@Required
	@DescriptionProperty
	public String getDescricaoItem() {
		return descricaoItem;
	}
	/**
	 * @param descricaoItem the descricaoItem to set
	 */
	public void setDescricaoItem(String descricaoItem) {
		this.descricaoItem = descricaoItem;
	}
	/**
	 * @return the valor
	 */
	@Required
	public Money getValor() {
		return valor;
	}
	/**
	 * @param valor the valor to set
	 */
	public void setValor(Money valor) {
		this.valor = valor;
	}
	/**
	 * @return the orcamento
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	public Orcamento getOrcamento() {
		return orcamento;
	}
	/**
	 * @param orcamento the orcamento to set
	 */
	public void setOrcamento(Orcamento orcamento) {
		this.orcamento = orcamento;
	}

}
