package br.com.mss.labqp.orcamento.entity;

import java.util.Date;

import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.springframework.format.annotation.DateTimeFormat;

import br.com.mss.labqp.FiltroListagemAudit;
import br.com.mss.labqp.cadastro.entity.Cliente;

public class OrcamentoFiltro extends FiltroListagemAudit {

	private Long id;
	private Date dataI;
	private Date dataF;
	private Integer validadeI;
	private Integer validadeF;
	private Cliente cliente;
	private Boolean comValoresUnitarios;
	
	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}
	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}
	/**
	 * @return the cliente
	 */
	public Cliente getCliente() {
		return cliente;
	}
	/**
	 * @param cliente the cliente to set
	 */
	public void setCliente(Cliente cliente) {
		this.cliente = cliente;
	}
	/**
	 * @return the dataI
	 */
	@DateTimeFormat
	@Temporal(TemporalType.DATE)
	public Date getDataI() {
		return dataI;
	}
	/**
	 * @param dataI the dataI to set
	 */
	public void setDataI(Date dataI) {
		this.dataI = dataI;
	}
	/**
	 * @return the dataF
	 */
	@DateTimeFormat
	@Temporal(TemporalType.DATE)
	public Date getDataF() {
		return dataF;
	}
	/**
	 * @param dataF the dataF to set
	 */
	public void setDataF(Date dataF) {
		this.dataF = dataF;
	}
	/**
	 * @return the validadeI
	 */
	@MaxLength(4)
	public Integer getValidadeI() {
		return validadeI;
	}
	/**
	 * @param validadeI the validadeI to set
	 */
	public void setValidadeI(Integer validadeI) {
		this.validadeI = validadeI;
	}
	/**
	 * @return the validadeF
	 */
	@MaxLength(4)
	public Integer getValidadeF() {
		return validadeF;
	}
	/**
	 * @param validadeF the validadeF to set
	 */
	public void setValidadeF(Integer validadeF) {
		this.validadeF = validadeF;
	}
	/**
	 * @return the comValoresUnitarios
	 */
	@DisplayName("Com valores unitrios")
	public Boolean getComValoresUnitarios() {
		return comValoresUnitarios;
	}
	/**
	 * @param comValoresUnitarios the comValoresUnitarios to set
	 */
	public void setComValoresUnitarios(Boolean comValoresUnitarios) {
		this.comValoresUnitarios = comValoresUnitarios;
	}

}
