package br.com.mss.labqp.orcamento.entity;

import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.types.Money;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBean;
import br.com.mss.labqp.cadastro.entity.TipoAmostra;

@Entity
@Table(name = "orcamentoTipoAmostra")
@DisplayName("Oramento - Tipos de Amostras")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_ORCAMENTO_TIPO_AMOSTRA_ID")
public class OrcamentoTipoAmostra extends BasicBean {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6366826378883380179L;
	private String descricao;
	private Orcamento orcamento;
	private TipoAmostra tipoAmostra;
	private List<ItemOrcamento> itensOrcamento;
	private Money valorTotal;

	/**
	 * @return the descricao
	 */

	@Column(length = 254)
	@MaxLength(254)
	public String getDescricao() {
		return descricao;
	}
	/**
	 * @param descricao the descricao to set
	 */
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}
	/**
	 * @return the orcamento
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	public Orcamento getOrcamento() {
		return orcamento;
	}
	/**
	 * @param orcamento the orcamento to set
	 */
	public void setOrcamento(Orcamento orcamento) {
		this.orcamento = orcamento;
	}
	/**
	 * @return the tipoAmostra
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	@Required
	public TipoAmostra getTipoAmostra() {
		return tipoAmostra;
	}
	/**
	 * @param tipoAmostra the tipoAmostra to set
	 */
	public void setTipoAmostra(TipoAmostra tipoAmostra) {
		this.tipoAmostra = tipoAmostra;
	}
	/**
	 * @return the itensOrcamento
	 */
	@OneToMany(mappedBy = "orcTipoAmostra",fetch=FetchType.LAZY)
	public List<ItemOrcamento> getItensOrcamento() {
		return itensOrcamento;
	}
	/**
	 * @param itensOrcamento the itensOrcamento to set
	 */
	public void setItensOrcamento(List<ItemOrcamento> itensOrcamento) {
		this.itensOrcamento = itensOrcamento;
	}
	/**
	 * @return the valorTotal
	 */
	@Transient
	public Money getValorTotal() {
		return valorTotal;
	}
	/**
	 * @param valorTotal the valorTotal to set
	 */
	public void setValorTotal(Money valorTotal) {
		this.valorTotal = valorTotal;
	}
	
	
}
