package br.com.mss.labqp.orcamento.service;

import java.util.List;

import org.nextframework.service.GenericService;

import br.com.mss.labqp.cadastro.entity.Ensaio;
import br.com.mss.labqp.orcamento.dao.ItemOrcamentoDAO;
import br.com.mss.labqp.orcamento.entity.ItemOrcamento;
import br.com.mss.labqp.orcamento.entity.OrcamentoDoc;
import br.com.mss.labqp.orcamento.entity.OrcamentoFiltro;
import br.com.mss.labqp.orcamento.entity.OrcamentoTipoAmostra;

public class ItemOrcamentoService extends GenericService<ItemOrcamento> {
	ItemOrcamentoDAO itemOrcamentoDAO;

	/**
	 * @param itemOrcamentoDAO the itemOrcamentoDAO to set
	 */
	public void setItemOrcamentoDAO(ItemOrcamentoDAO itemOrcamentoDAO) {
		this.itemOrcamentoDAO = itemOrcamentoDAO;
	}

	public void gravaItensOrcamento(List<Ensaio> paList, OrcamentoTipoAmostra orcTpAmostra){
		ItemOrcamento io;
		List<ItemOrcamento> ioList = findBy(orcTpAmostra, false, "");
		if (ioList != null && ioList.size() > 0) {
			for (ItemOrcamento itemOrcamento : ioList) {
				genericDAO.delete(itemOrcamento);
			}
		}
		for (Ensaio ensaio : paList) {
			if (ensaio.getSelecionado() == true) {
				io = new ItemOrcamento();
				io.setOrcTipoAmostra(orcTpAmostra);
				io.setEnsaio(ensaio);
				io.setValor(ensaio.getValor());
				genericDAO.saveOrUpdate(io);
			}	
		}
		
	}
	
	public List<OrcamentoDoc> orcamentoDoc(OrcamentoFiltro filtro) {
		return itemOrcamentoDAO.orcamentoDoc(filtro);
	}
	
	public List<ItemOrcamento> itens(Long orcTipoAmostraId) {
		return itemOrcamentoDAO.itens(orcTipoAmostraId);
		
	}
}
