package br.com.mss.labqp.programacao.dao;

import org.nextframework.controller.crud.FiltroListagem;
import org.nextframework.persistence.QueryBuilder;

import br.com.mss.labqp.GenericAuditDAO;
import br.com.mss.labqp.geral.FiltroExcluidoEnum;
import br.com.mss.labqp.programacao.entity.Programacao;
import br.com.mss.labqp.programacao.entity.ProgramacaoFiltro;

public class ProgramacaoDAO extends GenericAuditDAO<Programacao> {

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateListagemQuery(org.nextframework.persistence.QueryBuilder, org.nextframework.controller.crud.FiltroListagem)
	 */
	@Override
	public void updateListagemQuery(QueryBuilder<Programacao> query,
			FiltroListagem _filtro) {
		query.joinFetch("programacao.orcamento");
		query.joinFetch("programacao.orcamento.cliente");
		ProgramacaoFiltro filtro = (ProgramacaoFiltro) _filtro;
		query.where("programacao.id = ?", filtro.getId());
		query.where("programacao.diaSemana = ?", filtro.getDiaSemana());
		query.whereLike("programacao.ponto", filtro.getPonto());
		if (filtro.getFiltroExcluido() != null) {
			if (filtro.getFiltroExcluido() == FiltroExcluidoEnum.SIM)
				query.where("programacao.dataExc is not null");
			else
				query.where("programacao.dataExc is null");

		}
	}

	/* (non-Javadoc)
	 * @see org.nextframework.persistence.GenericDAO#updateEntradaQuery(org.nextframework.persistence.QueryBuilder)
	 */
	@Override
	public void updateEntradaQuery(QueryBuilder<Programacao> query) {
		query.joinFetch("programacao.orcamento");
		query.joinFetch("programacao.orcamento.cliente");
		super.updateEntradaQuery(query);
	}

	
}
