/**
 * 
 */
package br.com.mss.labqp.programacao.entity;

import javax.persistence.Column;
import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBean;
import br.com.mss.labqp.geral.entity.Endereco;

/**
 * @author Marlon
 *
 */
@Entity
@Table(name = "kit")
@DisplayName("Kit")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_KIT_ID")
public class Kit extends BasicBean {

	/**
	 * 
	 */
	private static final long serialVersionUID = 4445202788055783557L;
	
	private Programacao programacao;
	private PontoColeta pontoColeta;
	private Endereco endereco;
	private String orientacao;
	
	
	/**
	 * @return the programacao
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	@Required
	public Programacao getProgramacao() {
		return programacao;
	}
	/**
	 * @param programacao the programacao to set
	 */
	public void setProgramacao(Programacao programacao) {
		this.programacao = programacao;
	}
	/**
	 * @return the pontoColeta
	 */
	@Embedded
	public PontoColeta getPontoColeta() {
		return pontoColeta;
	}
	/**
	 * @param pontoColeta the pontoColeta to set
	 */
	public void setPontoColeta(PontoColeta pontoColeta) {
		this.pontoColeta = pontoColeta;
	}
	/**
	 * @return the endereco
	 */
	@Embedded
	public Endereco getEndereco() {
		return endereco;
	}
	/**
	 * @param endereco the endereco to set
	 */
	public void setEndereco(Endereco endereco) {
		this.endereco = endereco;
	}
	/**
	 * @return the orientacao
	 */
	@Column(length = 400)
	@MaxLength(400)
	@DisplayName("Observao")
	public String getOrientacao() {
		return orientacao;
	}
	/**
	 * @param orientacao the orientacao to set
	 */
	public void setOrientacao(String orientacao) {
		this.orientacao = orientacao;
	}
	
	
	

}
