/**
 * 
 */
package br.com.mss.labqp.programacao.entity;

import javax.persistence.Column;
import javax.persistence.Embeddable;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

/**
 * @author Marlon
 *
 */
@Embeddable
public class PontoColeta {

	private String ponto;
	private String latitude;
	private String longitude;
	private String idGps;
	
	@Required
	@DisplayName("Ponto de Coleta")
	@MaxLength(60)
	@Column(length = 60,nullable=false)
	public String getPonto() {
		return ponto;
	}

	/**
	 * @param ponto the ponto to set
	 */
	public void setPonto(String ponto) {
		this.ponto = ponto;
	}

	/**
	 * @return the latitude
	 */
	@MaxLength(20)
	@Column(length = 20)
	public String getLatitude() {
		return latitude;
	}

	/**
	 * @param latitude the latitude to set
	 */
	public void setLatitude(String latitude) {
		this.latitude = latitude;
	}

	/**
	 * @return the longitude
	 */
	@MaxLength(20)
	@Column(length = 20)
	public String getLongitude() {
		return longitude;
	}

	/**
	 * @param longitude the longitude to set
	 */
	public void setLongitude(String longitude) {
		this.longitude = longitude;
	}

	/**
	 * @return the idGps
	 */
	@DisplayName("Identifio GPS")
	@MaxLength(20)
	@Column(length = 20)
	public String getIdGps() {
		return idGps;
	}

	/**
	 * @param idGps the idGps to set
	 */
	public void setIdGps(String idGps) {
		this.idGps = idGps;
	}

	
}
