package br.com.mss.labqp.requisicao.dao;

import java.util.List;

import org.nextframework.persistence.DefaultOrderBy;
import org.nextframework.persistence.GenericDAO;
import org.nextframework.persistence.QueryBuilder;

import br.com.mss.labqp.requisicao.entity.ItemRequisicaoAnalise;
import br.com.mss.labqp.requisicao.entity.ItemRequisicaoAnaliseFiltro;

@DefaultOrderBy("itemRequisicaoAnalise.parametroAnalise.nome")
public class ItemRequisicaoAnaliseDAO extends GenericDAO<ItemRequisicaoAnalise> {


	public List<ItemRequisicaoAnalise> findByFiltro(ItemRequisicaoAnaliseFiltro filtro){
		QueryBuilder<ItemRequisicaoAnalise> query = montaQuery(this.query(), filtro);
		return query.list();
	}

	private QueryBuilder<ItemRequisicaoAnalise> montaQuery(QueryBuilder<ItemRequisicaoAnalise> query, ItemRequisicaoAnaliseFiltro filtro) {
		query.joinFetch("itemRequisicaoAnalise.requisicaoAnalise");
		query.joinFetch("itemRequisicaoAnalise.requisicaoAnalise.cliente");
		query.where("itemRequisicaoAnalise.id = ?", filtro.getId());
		query.where("itemRequisicaoAnalise.requisicaoAnalise = ? ", filtro.getRequisicaoAnalise());
		query.where("itemRequisicaoAnalise.parametroAnalise = ? ", filtro.getEnsaioAnalise());
		query.where("itemRequisicaoAnalise.unidadeMedida = ? ", filtro.getUnidadeMedida());
		query.where("itemRequisicaoAnalise.metodologia = ? ", filtro.getMetodologia());
		query.where("itemRequisicaoAnalise.requisicaoAnalise.situacaoRequisicaoEnum = ? ", filtro.getSituacaoRequisicaoEnum());
		query.openParentheses();
		query.where("itemRequisicaoAnalise.resultado is null or itemRequisicaoAnalise.resultado = ''");
		query.closeParentheses();
		return query;	
	}	
}
