package br.com.mss.labqp.requisicao.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.types.Money;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.Required;

import br.com.mss.labqp.BasicBean;
import br.com.mss.labqp.cadastro.entity.MetodoAnalitico;
import br.com.mss.labqp.cadastro.entity.Ensaio;
import br.com.mss.labqp.cadastro.entity.Unidade;
import br.com.mss.labqp.geral.FlagSimNaoEnum;

/**
 * 
 * @author mscheffer
 * 23/05/2011
 * 
 */
@Entity
@Table(name = "itemRequisicaoAnalise")
@DisplayName("Item Requisio Anlise")
@SequenceGenerator(allocationSize = 1, name = "SEQUENCE", sequenceName = "SQ_ITEM_REQANALISE_ID")
public class ItemRequisicaoAnalise extends BasicBean {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3389388365699823981L;
	private RequisicaoAnalise requisicaoAnalise;
	private Ensaio ensaio;
	private String resultado;
	private Unidade unidade;
	private MetodoAnalitico metodoAnalitico;
	private String vmp;
	private String ld;
	private Money valor;
	
	private FlagSimNaoEnum coletado; // Informao colocada quando a 
									// coleta tiver o auxilio de um Smartphone.
	
	
	/**
	 * @return the vmp
	 */
	@Column(length = 20)
	@MaxLength(20)
	@DisplayName("VMP")
	public String getVmp() {
		return vmp;
	}
	/**
	 * @param vmp the vmp to set
	 */
	public void setVmp(String vmp) {
		this.vmp = vmp;
	}
	/**
	 * @return the metodoAnalitico
	 */
	@ManyToOne(fetch = FetchType.EAGER)
	public MetodoAnalitico getMetodoAnalitico() {
		return metodoAnalitico;
	}
	/**
	 * @param metodoAnalitico the metodoAnalitico to set
	 */
	public void setMetodoAnalitico(MetodoAnalitico metodoAnalitico) {
		this.metodoAnalitico = metodoAnalitico;
	}
	/**
	 * @return the requisicaoAnalise
	 */
	@ManyToOne(fetch = FetchType.LAZY)
	@Required
	public RequisicaoAnalise getRequisicaoAnalise() {
		return requisicaoAnalise;
	}
	/**
	 * @param requisicaoAnalise the requisicaoAnalise to set
	 */
	public void setRequisicaoAnalise(RequisicaoAnalise requisicaoAnalise) {
		this.requisicaoAnalise = requisicaoAnalise;
	}
	/**
	 * @return the ensaio
	 */
	@ManyToOne(fetch = FetchType.EAGER)
	@Required
	@DisplayName("Ensaio de Anlise")
	public Ensaio getEnsaio() {
		return ensaio;
	}
	/**
	 * @param ensaio the ensaio to set
	 */
	public void setEnsaio(Ensaio ensaio) {
		this.ensaio = ensaio;
	}
	/**
	 * @return the resultado
	 */
	@Column(length = 20)
	@MaxLength(20)
	public String getResultado() {
		return resultado;
	}
	/**
	 * @param resultado the resultado to set
	 */
	public void setResultado(String resultado) {
		this.resultado = resultado;
	}
	/**
	 * @return the unidade
	 */
	@ManyToOne(fetch = FetchType.EAGER)
	public Unidade getUnidade() {
		return unidade;
	}
	/**
	 * @param unidade the unidade to set
	 */
	public void setUnidade(Unidade unidade) {
		this.unidade = unidade;
	}
	/**
	 * @return the valor
	 */
	public Money getValor() {
		return valor;
	}
	/**
	 * @param valor the valor to set
	 */
	public void setValor(Money valor) {
		this.valor = valor;
	}
	/**
	 * @return the coletado
	 */
	public FlagSimNaoEnum getColetado() {
		return coletado;
	}
	/**
	 * @param coletado the coletado to set
	 */
	public void setColetado(FlagSimNaoEnum coletado) {
		this.coletado = coletado;
	}
	/**
	 * @return the ld
	 */
	@Column(length = 20)
	@MaxLength(20)
	@DisplayName("LD")
	public String getLd() {
		return ld;
	}
	/**
	 * @param ld the ld to set
	 */
	public void setLd(String ld) {
		this.ld = ld;
	}
	
}
