package br.com.mss.labqp.requisicao.entity;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.MaxLength;
import org.nextframework.validation.annotation.MaxValue;
import org.nextframework.validation.annotation.MinLength;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.format.annotation.DateTimeFormat.ISO;

import br.com.mss.labqp.FiltroListagemAudit;
import br.com.mss.labqp.cadastro.entity.Cliente;
import br.com.mss.labqp.cadastro.entity.Coletador;
import br.com.mss.labqp.cadastro.entity.TipoAmostra;
import br.com.mss.labqp.financeiro.entity.Documento;
import br.com.mss.labqp.geral.MesEnum;
import br.com.mss.labqp.geral.SituacaoRequisicaoEnum;

public class RequisicaoAnaliseFiltro extends FiltroListagemAudit {

	private Long id;
	private Coletador coletador;
	private Date dataColeta;
	private Date dataEntrada;
	private Cliente cliente;
	private TipoAmostra tipoAmostra;
	private String identificaoAmostra;
	private Date dataSaida;
	private String localColeta;
	private SituacaoRequisicaoEnum situacaoRequisicaoEnum;
	private Documento documento;
	private String observacao;
    private MesEnum mes;
    private Short ano;
	private Date dataI;
	private Date dataF;
	private String nf;
	private Date vencimento;
	
	/**
	 * @return the nf
	 */
	public String getNf() {
		return nf;
	}
	/**
	 * @param nf the nf to set
	 */
	public void setNf(String nf) {
		this.nf = nf;
	}
	/**
	 * @return the vencimento
	 */
	@DateTimeFormat(iso=ISO.DATE,pattern="dd/MM/yyyy")
	@Temporal(TemporalType.DATE)
	public Date getVencimento() {
		return vencimento;
	}
	/**
	 * @param vencimento the vencimento to set
	 */
	public void setVencimento(Date vencimento) {
		this.vencimento = vencimento;
	}
	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}
	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}
	/**
	 * @return the coletador
	 */
	public Coletador getColetador() {
		return coletador;
	}
	/**
	 * @param coletador the coletador to set
	 */
	public void setColetador(Coletador coletador) {
		this.coletador = coletador;
	}
	/**
	 * @return the datahoraColeta
	 */
	@DateTimeFormat(iso=ISO.DATE,pattern="dd/MM/yyyy")
	@Temporal(TemporalType.DATE)
	public Date getDataColeta() {
		return dataColeta;
	}
	/**
	 * @param datahoraColeta the datahoraColeta to set
	 */
	public void setDataColeta(Date dataColeta) {
		this.dataColeta = dataColeta;
	}
	/**
	 * @return the dataEntrada
	 */
	@DateTimeFormat()
	@Temporal(TemporalType.DATE)
	public Date getDataEntrada() {
		return dataEntrada;
	}
	/**
	 * @param dataEntrada the dataEntrada to set
	 */
	public void setDataEntrada(Date dataEntrada) {
		this.dataEntrada = dataEntrada;
	}
	/**
	 * @return the tipoAmostra
	 */
	public TipoAmostra getTipoAmostra() {
		return tipoAmostra;
	}
	/**
	 * @param tipoAmostra the tipoAmostra to set
	 */
	public void setTipoAmostra(TipoAmostra tipoAmostra) {
		this.tipoAmostra = tipoAmostra;
	}
	/**
	 * @return the identificaoAmostra
	 */
	@DisplayName("Identificao da Amostra)")
	@Column(length = 100)
	@MaxLength(100)
	public String getIdentificaoAmostra() {
		return identificaoAmostra;
	}
	/**
	 * @param identificaoAmostra the identificaoAmostra to set
	 */
	public void setIdentificaoAmostra(String identificaoAmostra) {
		this.identificaoAmostra = identificaoAmostra;
	}
	/**
	 * @return the dataSaida
	 */
	@DateTimeFormat()
	@Temporal(TemporalType.DATE)
	public Date getDataSaida() {
		return dataSaida;
	}
	/**
	 * @param dataSaida the dataSaida to set
	 */
	public void setDataSaida(Date dataSaida) {
		this.dataSaida = dataSaida;
	}
	/**
	 * @return the localColeta
	 */
	@DisplayName("Local da Coleta)")
	@Column(length = 50)
	@MaxLength(50)
	public String getLocalColeta() {
		return localColeta;
	}
	/**
	 * @param localColeta the localColeta to set
	 */
	public void setLocalColeta(String localColeta) {
		this.localColeta = localColeta;
	}
	/**
	 * @return the cliente
	 */
	public Cliente getCliente() {
		return cliente;
	}
	/**
	 * @param cliente the cliente to set
	 */
	public void setCliente(Cliente cliente) {
		this.cliente = cliente;
	}
	/**
	 * @return the situacaoRequisicaoEnum
	 */
	@DisplayName("Situao")
	public SituacaoRequisicaoEnum getSituacaoRequisicaoEnum() {
		return situacaoRequisicaoEnum;
	}
	/**
	 * @param situacaoRequisicaoEnum the situacaoRequisicaoEnum to set
	 */
	public void setSituacaoRequisicaoEnum(
			SituacaoRequisicaoEnum situacaoRequisicaoEnum) {
		this.situacaoRequisicaoEnum = situacaoRequisicaoEnum;
	}
	/**
	 * @return the documento
	 */
	public Documento getDocumento() {
		return documento;
	}
	/**
	 * @param documento the documento to set
	 */
	public void setDocumento(Documento documento) {
		this.documento = documento;
	}
	/**
	 * @return the observacao
	 */
	@Column(length = 150)
	@MaxLength(150)
	@DisplayName("Observao")
	public String getObservacao() {
		return observacao;
	}
	/**
	 * @param observacao the observacao to set
	 */
	public void setObservacao(String observacao) {
		this.observacao = observacao;
	}
	/**
	 * @return the mes
	 */
	public MesEnum getMes() {
		return mes;
	}
	/**
	 * @param mes the mes to set
	 */
	public void setMes(MesEnum mes) {
		this.mes = mes;
	}
	/**
	 * @return the ano
	 */
	@Column(length = 4)
	@MaxLength(4)
	@MinLength(4)
	@MaxValue(3000)
	public Short getAno() {
		return ano;
	}
	/**
	 * @param ano the ano to set
	 */
	public void setAno(Short ano) {
		this.ano = ano;
	}
	/**
	 * @return the dataI
	 */
	@DateTimeFormat
	@Temporal(TemporalType.DATE)
	public Date getDataI() {
		return dataI;
	}
	/**
	 * @param dataI the dataI to set
	 */
	public void setDataI(Date dataI) {
		this.dataI = dataI;
	}
	/**
	 * @return the dataF
	 */
	@DateTimeFormat
	@Temporal(TemporalType.DATE)
	public Date getDataF() {
		return dataF;
	}
	/**
	 * @param dataF the dataF to set
	 */
	public void setDataF(Date dataF) {
		this.dataF = dataF;
	}
	/**
	 * @return the validadeI
	 */
}
