package br.com.mss.labqp.requisicao.service;

import java.util.List;

import org.nextframework.service.GenericService;

import br.com.mss.labqp.geral.SituacaoRequisicaoEnum;
import br.com.mss.labqp.requisicao.dao.RequisicaoAnaliseDAO;
import br.com.mss.labqp.requisicao.entity.ExtratoMensal;
import br.com.mss.labqp.requisicao.entity.ItemRequisicaoAnalise;
import br.com.mss.labqp.requisicao.entity.QtdeRequisicao;
import br.com.mss.labqp.requisicao.entity.RequisicaoAnalise;
import br.com.mss.labqp.requisicao.entity.RequisicaoAnaliseFiltro;

public class RequisicaoAnaliseService extends GenericService<RequisicaoAnalise> {

	private RequisicaoAnaliseDAO requisicaoAnaliseDAO;

	/**
	 * @param requisicaoAnaliseDAO the requisicaoAnaliseDAO to set
	 */
	public void setRequisicaoAnaliseDAO(RequisicaoAnaliseDAO requisicaoAnaliseDAO) {
		this.requisicaoAnaliseDAO = requisicaoAnaliseDAO;
	}

	public List<RequisicaoAnalise> findByFiltro(RequisicaoAnaliseFiltro filtro){
		return requisicaoAnaliseDAO.findByFiltro(filtro);
	}

	/* (non-Javadoc)
	 * @see org.nextframework.service.GenericService#saveOrUpdate(java.lang.Object)
	 */
	@Override
	public void saveOrUpdate(RequisicaoAnalise bean) {
		// faz uma verificao se todos os resultados foram inseridos. 
		//  Se sim, atera a situao caso ela seja "AGUARDANDO_RESULTADOS"
		// Este teste vale somente numa atualizao do registro
		if (bean.getId() != null &&
				bean.getSituacaoRequisicaoEnum() == SituacaoRequisicaoEnum.AGUARDANDO_RESULTADOS){
			Boolean troca = true;
			List<ItemRequisicaoAnalise> iraList = bean.getItensRequisicaoAnalise();
			if (iraList != null && iraList.size() > 0) {
				for (ItemRequisicaoAnalise ira : iraList) {
					troca = (!ira.getResultado().isEmpty());
					if (!troca) break;
				}
			}
			if (troca) {
				bean.setSituacaoRequisicaoEnum(SituacaoRequisicaoEnum.RESULTADOS_INCLUIDOS);
			}
		}	
		super.saveOrUpdate(bean);
	}

	public List<ExtratoMensal> extratoRequisicao(RequisicaoAnaliseFiltro filtro){
		return requisicaoAnaliseDAO.extratoRequisicao(filtro);
	}

	public List<Long> documentosExtrato(RequisicaoAnaliseFiltro filtro) {
		return requisicaoAnaliseDAO.documentosExtrato(filtro);
	}

	public List<ExtratoMensal> extratoItensAdicionais(RequisicaoAnaliseFiltro filtro){
		return requisicaoAnaliseDAO.extratoItensAdicionais(filtro);
	}

	public List<ExtratoMensal> extratoImpostos(RequisicaoAnaliseFiltro filtro){
		return requisicaoAnaliseDAO.extratoImpostos(filtro);
	}

	public List<QtdeRequisicao> qtdeRequisicao(RequisicaoAnaliseFiltro filtro){
		return requisicaoAnaliseDAO.qtdeRequisicao(filtro);
	}
}
 